<?PHP
//Code_Project Class (extends Pool_Project)
//This class impliments the project object for the code pool

require_once('pool_project.class.php');

class Code_Project extends Pool_Project{
	public $ini_file = 'code_pool.ini';
	
	//methods
	public function new_project($form_data){
		//creates a new project entry in the database
		//if $form_data['hr_id'] != -1, it instead updates the old project
		
		//Get the project id
		if($form_data['intent_id'] == -1){
			$form_data['hr_id'] = $this->new_hr_id('code', $form_data['title']);
		
			//Save the project
			$intent_count = $form_data['stage'] == 'intent' ? 1 : 0;
			$project_data = array($form_data['hr_id'], $form_data['title'], $form_data['description'], $intent_count);
			$q = 'INSERT INTO `project` (`hr_id`,`title`,`description`,`pool_type`,`intent_num`,`last_modified`)
					VALUES (?, ?, ?,"code", ?, NOW()) ON DUPLICATE KEY UPDATE `title` = VALUES(`title`), `last_modified` = NOW()';
			$result = $this->data->query($q, $project_data);
			if(!$this->check_db($result, 'new_project')) return false;
		
			//Get back the id of the project just entered
			$this->id = $this->data->getOne('SELECT `id` FROM `project` WHERE `hr_id` = ?', $form_data['hr_id']);
		} else {
			$this->id = Pool_Project::resolve_artifact_id('intent', $form_data['intent_id']);
			$q = 'UPDATE `project` SET `title` = ?, `last_modified` = NOW() WHERE `id` = ?';
			$result = $this->data->query($q, array($form_data['title'], $this->id));
			if(!$this->check_db($result, 'new_project')) return false;			
		}
		
		$this->load_all();
		//Link subjects
		$this->save_subjects($form_data['subjects']);
	}
}
?>