<?PHP
//Subject.php .1
//Class for dealing with subjects in the pool

require_once('db_init.php');

class Subject{
	public $id = '';					//Database fields
	public $hr_id = '';
	public $written = '';
	public $rating = '';
	public $basis = '';
	public $connectivity = '';
	
	//public methods
	public function __construct($construct_var){
		//$id is the number id of the subject
		//Set up the db object
		$this->data = &$GLOBALS['data'];
		
		//if(is_array($construct_var)) $this->new_review($construct_var);
		//else{
			$this->id = $construct_var;
			$this->load_subject($construct_var);
		//}
	}
	
	public function load_subject($id){
		//Loads data from the database
		$q = 'SELECT * FROM `subject` WHERE `id` = ?';
		$result = $this->data->getRow($q, array($id));
		if(!$this->check_db($result, 'load_subject')) return false;
		foreach($result as $key => $value) $this->$key = $value;
	}
	
	//protected methods
	protected function check_db($result, $func){
		//Return true if $result is not DB::Error, false and an error otherwise
		if(DB::isError($result)){
			trigger_error("Pool_Project->$func failed: ".$this->data->last_query." \n".$result->getMessage(), E_USER_WARNING);	
			return false;
		} else return true;
	}
	
	//static methods
	public static function get_all(){
	//gets an array of all subjects in the pool, with all columns.
	
		//Get the db
		$data = &$GLOBALS['data'];
		
		$q = 'SELECT * FROM `subject` ORDER BY `written` ASC';
		$result = $data->getAll($q, array());
		if(DB::isError($result)){
			trigger_error("Subject->$func failed: ".$data->last_query." \n".$result->getMessage(), E_USER_WARNING);	
			return false;
		}

		//format array
		$subjects = array();
		foreach($result as $subject) $subjects[$subject['id']] = $subject;
		return $subjects;
	}
	
/* 	public static function write_js_all(){
	//write out the javascript array for all subjects
		
		//Get subjects
		$subjects = Subject::get_all();
		
		//write out array
		require_once('smarty_init.php');
		$smarty = &$GLOBALS['smarty'];
		
		$smarty->assign('subjects', $subjects);
		$smarty->left_delimiter = '<{';
		$smarty->right_delimiter = '}>';		
		$smarty->display('js_subject_array.tpl');
		$smarty->left_delimiter = '{';
		$smarty->right_delimiter = '}';
	} */
	
	public static function write_js_all_short(){
	//write out the abbreviated javascript array for all subjects
		
		//Get subjects
		$subjects = Subject::get_all();
		
		//write out array
		require_once('smarty_init.php');
		$smarty = &$GLOBALS['smarty'];
		
		$smarty->assign('subjects', $subjects);
		$smarty->left_delimiter = '<{';
		$smarty->right_delimiter = '}>';		
		$smarty->display('js_subject_array_short.tpl');
		$smarty->left_delimiter = '{';
		$smarty->right_delimiter = '}';
	}
}


?>