-- phpMyAdmin SQL Dump
-- version 2.10.2
-- http://www.phpmyadmin.net
-- 
-- Host: localhost
-- Generation Time: Aug 03, 2008 at 02:00 PM
-- Server version: 5.0.41
-- PHP Version: 5.2.5

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

-- 
-- Database: `pool-public`
-- 

-- --------------------------------------------------------

-- 
-- Table structure for table `affinity`
-- 

CREATE TABLE `affinity` (
  `subject1` int(8) unsigned NOT NULL default '0',
  `subject2` int(8) unsigned NOT NULL default '0',
  `bases` tinyint(4) NOT NULL default '0',
  `hr_link` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`subject1`,`subject2`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 
-- Dumping data for table `affinity`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `approach`
-- 

CREATE TABLE `approach` (
  `id` int(8) unsigned NOT NULL auto_increment,
  `hr_id` varchar(40) NOT NULL default '',
  `intent_id` int(8) unsigned NOT NULL default '0',
  `pool_type` varchar(16) NOT NULL default '',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `description` text NOT NULL,
  `uri_view` varchar(255) default NULL,
  `uri_source` varchar(255) default NULL,
  `type` varchar(40) NOT NULL default '',
  `requests` varchar(255) default NULL,
  `recorder_id` int(8) unsigned NOT NULL default '0',
  `js_cache` text NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `hr_id` (`hr_id`),
  KEY `intent_id` (`intent_id`,`pool_type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `approach`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `artifact_ratings`
-- 

CREATE TABLE `artifact_ratings` (
  `artifact_id` int(8) unsigned NOT NULL default '0',
  `artifact_type` enum('project','intent','approach','release','reference') NOT NULL default 'project',
  `category` varchar(16) NOT NULL default '',
  `rating` decimal(4,2) unsigned NOT NULL default '0.00',
  `basis` tinyint(3) unsigned NOT NULL default '0',
  `hr_link` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`artifact_id`,`category`,`artifact_type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 
-- Dumping data for table `artifact_ratings`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `aspects`
-- 

CREATE TABLE `aspects` (
  `artifact_id` int(8) unsigned NOT NULL default '0',
  `artifact_type` enum('project','intent','approach','release','reference') NOT NULL default 'project',
  `aspect` varchar(128) NOT NULL default '',
  `hr_link` varchar(100) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`artifact_id`,`artifact_type`,`aspect`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 
-- Dumping data for table `aspects`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `attribution`
-- 

CREATE TABLE `attribution` (
  `id` int(8) unsigned NOT NULL auto_increment,
  `name` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `hr_id` varchar(128) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci COMMENT='attributions are for references, not projects' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `attribution`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `attribution_ratings`
-- 

CREATE TABLE `attribution_ratings` (
  `attribution_id` int(8) unsigned NOT NULL default '0',
  `category` varchar(16) NOT NULL default '',
  `hr_id` varchar(40) NOT NULL default '',
  `rating` decimal(4,2) unsigned NOT NULL default '0.00',
  `basis` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`attribution_id`,`category`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 
-- Dumping data for table `attribution_ratings`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `intent`
-- 

CREATE TABLE `intent` (
  `id` int(8) unsigned NOT NULL auto_increment,
  `hr_id` varchar(40) NOT NULL default '',
  `pool_type` varchar(16) NOT NULL default '',
  `title` varchar(40) NOT NULL default '',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `description` text NOT NULL,
  `uri_view` varchar(255) default NULL,
  `requests` varchar(255) default NULL,
  `recorder_id` int(8) unsigned NOT NULL default '0',
  `js_cache` text NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `hr_id` (`hr_id`),
  KEY `pool_type` (`pool_type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `intent`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `person`
-- 

CREATE TABLE `person` (
  `id` int(8) unsigned NOT NULL auto_increment,
  `hr_id` varchar(40) NOT NULL default '',
  `password` varchar(42) NOT NULL default '',
  `email` varchar(128) NOT NULL default '',
  `uri` varchar(128) default NULL,
  `description` text,
  `themes` varchar(255) default NULL,
  `last_login` datetime default NULL,
  `recorder_id` int(8) unsigned NOT NULL default '0',
  `thumb_id` int(8) unsigned default NULL,
  `written` varchar(48) NOT NULL default '',
  `permissions` int(1) NOT NULL default '0',
  `js_cache` longtext NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

-- 
-- Dumping data for table `person`
-- 

INSERT INTO `person` VALUES (1, 'per_admin01', '*4ACFE3202A5FF5CF467898FC58AAB1D615029441', 'admin@example.com', NULL, 'Admin user', NULL, NULL, 1, NULL, 'Administrator', 2, '{	\r\n			person:{\r\n				id: ''1'',\r\n				hr_id: ''per_admin01'',\r\n				email: ''admin@example.com'',\r\n				uri: '''',\r\n				description: ''Admin user'',\r\n				themes: '''',\r\n				last_login: '''',\r\n				thumb_id: '''',\r\n				written: ''Administrator'',\r\n				ratings:{					''conceptual'': {''self_rating'': ''0'', ''rating'': ''0.00'', ''basis'': ''0''},			\r\n					''perceptual'': {''self_rating'': ''0'', ''rating'': ''0.00'', ''basis'': ''0''},			\r\n					''technical'': {''self_rating'': ''0'', ''rating'': ''0.00'', ''basis'': ''0''}			\r\n				},				\r\n				permissions: ''2''\r\n			},\r\n			reviews_by:{\r\n							},\r\n			reviews_of:{\r\n			},\r\n			projects:{			\r\n			}\r\n}');

-- --------------------------------------------------------

-- 
-- Table structure for table `person_artifact`
-- 

CREATE TABLE `person_artifact` (
  `person_id` int(8) unsigned NOT NULL default '0',
  `artifact_id` int(8) unsigned NOT NULL default '0',
  `artifact_type` enum('project','intent','approach','release') NOT NULL default 'project',
  `role` varchar(16) NOT NULL default '',
  `hr_link` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`person_id`,`artifact_id`,`role`,`artifact_type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 
-- Dumping data for table `person_artifact`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `person_ratings`
-- 

CREATE TABLE `person_ratings` (
  `person_id` int(8) unsigned NOT NULL default '0',
  `category` varchar(16) NOT NULL default '',
  `hr_id` varchar(40) NOT NULL default '',
  `rating` decimal(4,2) unsigned NOT NULL default '0.00',
  `basis` tinyint(3) unsigned NOT NULL default '0',
  `self_rating` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`person_id`,`category`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 
-- Dumping data for table `person_ratings`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `project`
-- 

CREATE TABLE `project` (
  `id` int(8) unsigned NOT NULL auto_increment,
  `hr_id` varchar(128) NOT NULL default '',
  `title` varchar(128) NOT NULL default '',
  `description` text NOT NULL,
  `pool_type` varchar(16) NOT NULL default '',
  `intent_num` tinyint(3) unsigned NOT NULL default '0',
  `approach_num` tinyint(3) unsigned NOT NULL default '0',
  `release_num` tinyint(3) unsigned NOT NULL default '0',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `rating` decimal(4,2) unsigned NOT NULL default '0.00',
  `basis` tinyint(3) unsigned NOT NULL default '0',
  `thumb_id` int(8) unsigned default NULL,
  `js_cache` text,
  `js_cache_short` text NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `hr_id` (`hr_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `project`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `project_artifact`
-- 

CREATE TABLE `project_artifact` (
  `project_id` int(8) unsigned NOT NULL default '0',
  `artifact_id` int(8) unsigned NOT NULL default '0',
  `artifact_type` enum('project','intent','approach','release') NOT NULL default 'project',
  `hr_link` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`project_id`,`artifact_id`,`artifact_type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 
-- Dumping data for table `project_artifact`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `project_subject`
-- 

CREATE TABLE `project_subject` (
  `project_id` int(8) unsigned NOT NULL default '0',
  `subject_id` int(8) unsigned NOT NULL default '0',
  `hr_link` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`project_id`,`subject_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 
-- Dumping data for table `project_subject`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `reference`
-- 

CREATE TABLE `reference` (
  `id` int(8) unsigned NOT NULL auto_increment,
  `title` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `pool_type` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `date_published` date default NULL,
  `citation` varchar(255) collate utf8_unicode_ci default NULL,
  `source_url` varchar(255) collate utf8_unicode_ci default NULL,
  `description` text collate utf8_unicode_ci NOT NULL,
  `recorder_id` int(8) unsigned NOT NULL default '0',
  `thumb_id` int(8) unsigned default NULL,
  `hr_id` varchar(128) collate utf8_unicode_ci NOT NULL default '',
  `js_cache` text collate utf8_unicode_ci NOT NULL,
  `js_cache_short` text collate utf8_unicode_ci NOT NULL,
  `rating` decimal(4,2) NOT NULL default '0.00',
  `basis` tinyint(4) NOT NULL default '0',
  `last_modified` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `hr_id` (`hr_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `reference`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `reference_attribution`
-- 

CREATE TABLE `reference_attribution` (
  `reference_id` int(8) unsigned NOT NULL default '0',
  `attribution_id` int(8) unsigned NOT NULL default '0',
  `hr_link` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`reference_id`,`attribution_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- 
-- Dumping data for table `reference_attribution`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `reference_subject`
-- 

CREATE TABLE `reference_subject` (
  `reference_id` int(8) unsigned NOT NULL default '0',
  `subject_id` int(8) unsigned NOT NULL default '0',
  `hr_link` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`reference_id`,`subject_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- 
-- Dumping data for table `reference_subject`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `relations`
-- 

CREATE TABLE `relations` (
  `id` int(8) NOT NULL auto_increment,
  `subject_id` int(8) unsigned NOT NULL default '0',
  `predicate_id` int(8) unsigned NOT NULL default '0',
  `relationship` enum('usesInCombination','transforms','cites','hasPredecessor') NOT NULL default 'hasPredecessor',
  `subject_type` varchar(16) NOT NULL default '',
  `predicate_type` varchar(16) NOT NULL default '',
  `value` tinyint(4) NOT NULL default '0',
  `description` text NOT NULL,
  `recorder_id` int(8) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `subject_id` (`subject_id`,`predicate_id`,`recorder_id`,`subject_type`,`predicate_type`,`relationship`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `relations`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `release`
-- 

CREATE TABLE `release` (
  `id` int(8) unsigned NOT NULL auto_increment,
  `hr_id` varchar(40) NOT NULL default '',
  `intent_id` int(8) unsigned NOT NULL default '0',
  `approach_id` int(8) unsigned NOT NULL default '0',
  `pool_type` varchar(16) NOT NULL default '',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `description` text,
  `uri_view` varchar(255) default NULL,
  `uri_source` varchar(255) default NULL,
  `recorder_id` int(8) unsigned NOT NULL default '0',
  `requests` varchar(255) default NULL,
  `js_cache` text NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `hr_id` (`hr_id`),
  KEY `intent_id` (`intent_id`,`approach_id`,`pool_type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `release`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `review`
-- 

CREATE TABLE `review` (
  `id` int(8) unsigned NOT NULL auto_increment,
  `artifact_id` int(10) unsigned NOT NULL default '0',
  `artifact_type` enum('project','intent','approach','release','reference') NOT NULL default 'project',
  `pool_type` varchar(32) NOT NULL default '',
  `rating` decimal(4,2) NOT NULL default '0.00',
  `hr_link` varchar(255) NOT NULL default '',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `description` text,
  `recorder_id` int(8) unsigned NOT NULL default '0',
  `js_cache` text,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `artifact_id` (`artifact_id`,`artifact_type`,`recorder_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `review`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `review_ratings`
-- 

CREATE TABLE `review_ratings` (
  `review_id` int(8) unsigned NOT NULL default '0',
  `category` varchar(16) NOT NULL default '',
  `hr_link` varchar(255) NOT NULL default '',
  `rating` tinyint(3) unsigned NOT NULL default '0',
  `description` text NOT NULL,
  PRIMARY KEY  (`review_id`,`category`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 
-- Dumping data for table `review_ratings`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `subject`
-- 

CREATE TABLE `subject` (
  `id` int(8) unsigned NOT NULL auto_increment,
  `hr_id` varchar(40) NOT NULL default '',
  `written` varchar(100) NOT NULL default '',
  `rating` decimal(4,2) unsigned NOT NULL default '0.00',
  `basis` tinyint(3) unsigned NOT NULL default '0',
  `connectivity` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `hr_id` (`hr_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=166 ;

-- 
-- Dumping data for table `subject`
-- 

INSERT INTO `subject` VALUES (1, 'the_history', 'history', 41.00, 2, 0);
INSERT INTO `subject` VALUES (3, 'the_community', 'community', 99.99, 12, 0);
INSERT INTO `subject` VALUES (4, 'the_story', 'story', 99.99, 8, 0);
INSERT INTO `subject` VALUES (8, 'the_government', 'government', 77.00, 1, 0);
INSERT INTO `subject` VALUES (10, 'the_privacy', 'privacy', 91.00, 1, 0);
INSERT INTO `subject` VALUES (20, 'the_symbolism', 'symbolism', 99.99, 2, 0);
INSERT INTO `subject` VALUES (26, 'the_politics', 'politics', 99.99, 1, 0);
INSERT INTO `subject` VALUES (27, 'the_fear', 'fear', 99.99, 1, 0);
INSERT INTO `subject` VALUES (28, 'the_game', 'game', 99.99, 1, 0);
INSERT INTO `subject` VALUES (29, 'the_text', 'text', 99.99, 2, 0);
INSERT INTO `subject` VALUES (30, 'the_animation', 'animation', 99.99, 1, 0);
INSERT INTO `subject` VALUES (31, 'the_network', 'network', 99.99, 4, 0);
INSERT INTO `subject` VALUES (32, 'the_art', 'art', 43.00, 11, 0);
INSERT INTO `subject` VALUES (33, 'the_fun', 'fun', 99.99, 1, 0);
INSERT INTO `subject` VALUES (35, 'the_audio', 'audio', 99.99, 1, 0);
INSERT INTO `subject` VALUES (36, 'the_college', 'college', 99.99, 2, 0);
INSERT INTO `subject` VALUES (51, 'the_berkeley', 'berkeley', 0.00, 0, 0);
INSERT INTO `subject` VALUES (53, 'the_collection', 'collection', 0.00, 0, 0);
INSERT INTO `subject` VALUES (54, 'the_communication', 'communication', 0.00, 0, 0);
INSERT INTO `subject` VALUES (59, 'the_sharing', 'sharing', 99.99, 2, 0);
INSERT INTO `subject` VALUES (64, 'the_news', 'news', 99.99, 2, 0);
INSERT INTO `subject` VALUES (68, 'the_technology', 'technology', 99.99, 2, 0);
INSERT INTO `subject` VALUES (75, 'the_life', 'life', 99.99, 2, 0);
INSERT INTO `subject` VALUES (77, 'the_time', 'time', 99.99, 2, 0);
INSERT INTO `subject` VALUES (103, 'the_access', 'access', 1.00, 1, 0);
INSERT INTO `subject` VALUES (104, 'the_body', 'body', 1.00, 1, 0);
INSERT INTO `subject` VALUES (105, 'the_data', 'data', 1.00, 1, 0);
INSERT INTO `subject` VALUES (106, 'the_defect', 'defect', 1.00, 1, 0);
INSERT INTO `subject` VALUES (107, 'the_economics', 'economics', 1.00, 1, 0);
INSERT INTO `subject` VALUES (108, 'the_education', 'education', 1.00, 1, 0);
INSERT INTO `subject` VALUES (110, 'the_entertainment', 'entertainment', 1.00, 1, 0);
INSERT INTO `subject` VALUES (111, 'the_evaluation', 'evaluation', 1.00, 1, 0);
INSERT INTO `subject` VALUES (112, 'the_family', 'family', 1.00, 1, 0);
INSERT INTO `subject` VALUES (113, 'the_gender', 'gender', 1.00, 1, 0);
INSERT INTO `subject` VALUES (114, 'the_ideology', 'ideology', 1.00, 1, 0);
INSERT INTO `subject` VALUES (115, 'the_interaction', 'interaction', 1.00, 1, 0);
INSERT INTO `subject` VALUES (116, 'the_mobility', 'mobility', 1.00, 1, 0);
INSERT INTO `subject` VALUES (118, 'the_nature', 'nature', 1.00, 1, 0);
INSERT INTO `subject` VALUES (119, 'the_navigation', 'navigation', 1.00, 1, 0);
INSERT INTO `subject` VALUES (120, 'the_performance', 'performance', 1.00, 1, 0);
INSERT INTO `subject` VALUES (121, 'the_psychology', 'psychology', 1.00, 1, 0);
INSERT INTO `subject` VALUES (122, 'the_society', 'society', 1.00, 1, 0);
INSERT INTO `subject` VALUES (123, 'the_space', 'space', 1.00, 1, 0);
INSERT INTO `subject` VALUES (124, 'the_visual', 'visual', 1.00, 1, 0);
INSERT INTO `subject` VALUES (128, 'the_law', 'law', 0.00, 0, 0);
INSERT INTO `subject` VALUES (129, 'the_simulation', 'simulation', 0.00, 0, 0);
INSERT INTO `subject` VALUES (134, 'the_science', 'science', 0.00, 0, 0);
INSERT INTO `subject` VALUES (135, 'the_relationships', 'relationships', 0.00, 0, 0);
INSERT INTO `subject` VALUES (137, 'the_architecture', 'architecture', 0.00, 0, 0);
INSERT INTO `subject` VALUES (138, 'the_code', 'code', 0.00, 0, 0);
INSERT INTO `subject` VALUES (139, 'the_hardware', 'hardware', 0.00, 0, 0);
INSERT INTO `subject` VALUES (140, 'the_identity', 'identity', 0.00, 0, 0);
INSERT INTO `subject` VALUES (141, 'the_installation', 'installation', 0.00, 0, 0);
INSERT INTO `subject` VALUES (142, 'the_interface', 'interface', 0.00, 0, 0);
INSERT INTO `subject` VALUES (143, 'the_language', 'language', 0.00, 0, 0);
INSERT INTO `subject` VALUES (144, 'the_movie', 'movie', 0.00, 0, 0);
INSERT INTO `subject` VALUES (145, 'the_violence', 'violence', 0.00, 0, 0);
INSERT INTO `subject` VALUES (147, 'the_blog', 'blog', 0.00, 0, 0);
INSERT INTO `subject` VALUES (148, 'the_browser', 'browser', 0.00, 0, 0);
INSERT INTO `subject` VALUES (149, 'the_desktop', 'desktop', 0.00, 0, 0);
INSERT INTO `subject` VALUES (150, 'the_security', 'security', 0.00, 0, 0);
INSERT INTO `subject` VALUES (151, 'the_api', 'API', 0.00, 0, 0);
INSERT INTO `subject` VALUES (152, 'the_class', 'class', 0.00, 0, 0);
INSERT INTO `subject` VALUES (153, 'the_client', 'client', 0.00, 0, 0);
INSERT INTO `subject` VALUES (154, 'the_driver', 'driver', 0.00, 0, 0);
INSERT INTO `subject` VALUES (155, 'the_extension', 'extension', 0.00, 0, 0);
INSERT INTO `subject` VALUES (156, 'the_framework', 'framework', 0.00, 0, 0);
INSERT INTO `subject` VALUES (157, 'the_object', 'object', 0.00, 0, 0);
INSERT INTO `subject` VALUES (158, 'the_opensource', 'open source', 0.00, 0, 0);
INSERT INTO `subject` VALUES (159, 'the_patch', 'patch', 0.00, 0, 0);
INSERT INTO `subject` VALUES (160, 'the_plugin', 'plugin', 0.00, 0, 0);
INSERT INTO `subject` VALUES (161, 'the_sensor', 'sensor', 0.00, 0, 0);
INSERT INTO `subject` VALUES (162, 'the_server', 'server', 0.00, 0, 0);
INSERT INTO `subject` VALUES (163, 'the_standard', 'standard', 0.00, 0, 0);
INSERT INTO `subject` VALUES (164, 'the_widget', 'widget', 0.00, 0, 0);
INSERT INTO `subject` VALUES (165, 'the_peertopeer', 'peer-to-peer', 0.00, 0, 0);

-- --------------------------------------------------------

-- 
-- Table structure for table `thumbs`
-- 

CREATE TABLE `thumbs` (
  `id` int(8) unsigned NOT NULL auto_increment,
  `size` int(8) unsigned NOT NULL default '0',
  `type` varchar(3) NOT NULL default '',
  `image` blob NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `thumbs`
-- 

