<?PHP
//inserts a new approach into the database
//Include init files
require_once('../../pool_init.php');
require_once('smarty_init.php');
require_once('db_init.php');
require_once('person.class.php');
require_once('pool_intent.class.php');
require_once('pool_approach.class.php');
require_once('pool_release.class.php');
require_once('code_project.class.php');
require_once('review.class.php');
require_once('subject.class.php');

//Make sure all the required fields are filled
if(!isset($_POST['intentId']) || !isset($_POST['artifactType'])){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'missing postvars');
	run_smarty();
}

if(!isset($_POST['contributor1']) || $_POST['contributor1'] == ''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must have at least one contributor to your approach.');
	run_smarty();
}

if(!isset($_POST['uri_view']) || $_POST['uri_view']  == ''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must supply a URI where your approach can be viewed.');
	run_smarty();
}

if(!isset($_POST['type']) || $_POST['type']  == ''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must select a type for your approach.');
	run_smarty();
}
if(!isset($_POST['description']) || $_POST['description'] == ''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must describe your approach.');
	run_smarty();
}
if(!isset($_POST['uri_view']) || ($_POST['uri_view'] != '' && substr($_POST['uri_view'], 0, 4) != 'http')){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'The URI for your approach must begin with "http://".');
	run_smarty();
}
if(!isset($_POST['uri_source']) || ($_POST['uri_source'] != '' && substr($_POST['uri_source'], 0, 4) != 'http')){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'The URI for your approach source must begin with "http://".');
	run_smarty();
}
//Authenticate the user
$oPerson = Pool_Person::cookie_auth();
if(!$oPerson){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'failed auth');
	run_smarty();
}

//Unescape the URL encoding in $_POST
foreach($_POST as &$postvar) {
	$postvar = urldecode($postvar);
	$postvar = stripslashes($postvar);
}
//Set up the data array to pass to Pool_Approach
//First match up contributors with their roles
$approach_data = array();
$approach_data['contributors'] = array();
$contributor_count = 0;
foreach($_POST as $key=>$field){
	if(strpos($key, 'contributor') !== false) $contributor_count++;
}
for($i=1; $i <= $contributor_count; $i++){
	$id_label = 'contributor'.$i;
	if($_POST[$id_label] != '177'){
		//177 is the ID of the empty user (legacy, sorry.)	
		//Make sure there are roles defined
		$roles_label = 'roles'.$i;
		if($_POST[$roles_label] == ''){
			$smarty->assign('success', false);
			$smarty->assign('reason', 'Please make sure all contributors have been assigned roles.');
			run_smarty();			
		}
		$roles_array = explode('|', $_POST[$roles_label]);
		//print_r($roles_array);
		$approach_data['contributors'][$_POST[$id_label]] = $roles_array;
	}
}
//Split the rights and types
$approach_data['aspects'] = explode('|', $_POST['rights']);
array_push($approach_data['aspects'], $_POST['combinations']);
array_push($approach_data['aspects'], $_POST['transformations']);
$approach_data['custom_rights'] = $_POST['customRights'];
$approach_data['type'] = explode('|', $_POST['type']);

//Add the rest of the required data
$approach_data['requests'] = $_POST['requests'];
$approach_data['description'] = $_POST['description'];
$approach_data['uri_view'] = $_POST['uri_view'];
$approach_data['uri_source'] = $_POST['uri_source'];
$approach_data['pool_type'] = 'code';
$approach_data['stage'] = 'approach';
$approach_data['recorder_id'] = $oPerson['id'];
$approach_data['intent_id'] = $_POST['intentId'];
$approach_data['approach_id'] = $_POST['approachId'];

//Add the review
$oApproach = new Pool_Approach($approach_data);
$oProject = new Code_Project($oApproach->project_id);

if(!$oProject || !$oApproach){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'failed intent or project');
	run_smarty();
} else {
	$smarty->assign('panelId', $_POST['panelId']);
	$smarty->assign('project_panelId', $_POST['projectPanelId']);
	$project_js = Pool_Project::get_cached_js_short($oProject->id);
	$smarty->assign('project_js', $project_js);
	if($approach_data['approach_id'] == -1) $smarty->assign('edit', false);
	else $smarty->assign('edit', true);
	$smarty->assign('success', true);
	run_smarty();
}

function run_smarty(){
	$smarty = &$GLOBALS['smarty'];

	$smarty->left_delimiter = '<{';
	$smarty->right_delimiter = '}>';		
	$smarty->display('js_code_approach_handler.tpl');
	$smarty->left_delimiter = '{';
	$smarty->right_delimiter = '}';	 
	die();
}
?>