<?PHP
//inserts a new intent and project into the database

//Include init files
require_once('../../pool_init.php');
require_once('smarty_init.php');
require_once('db_init.php');
require_once('person.class.php');
require_once('pool_intent.class.php');
require_once('pool_approach.class.php');
require_once('pool_release.class.php');
require_once('code_project.class.php');
require_once('review.class.php');
require_once('subject.class.php');

//Make sure all the required fields are filled
if(!isset($_POST['intentId']) || !isset($_POST['artifactType'])){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'missing postvars');
	run_smarty();
}

if(!isset($_POST['title']) || $_POST['title'] == ''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'Intent title must not be blank.');
	run_smarty();	
}

if(!isset($_POST['description']) || $_POST['description'] == ''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'Description must not be blank.');
	run_smarty();	
}

if(!isset($_POST['contributor1']) || $_POST['contributor1'] == ''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must have at least one contributor for an intent.');
	run_smarty();	
}

//if(!isset($_POST['behaviors']) || $_POST['behaviors'] == ''){
//	$smarty->assign('success', false);
//	$smarty->assign('reason', 'You must choose at least one behavior for your intent.');
//	run_smarty();	
//}

if(!isset($_POST['uri_view']) || ($_POST['uri_view'] != '' && substr($_POST['uri_view'], 0, 4) != 'http')){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'The URI for your intent must begin with "http://".');
	run_smarty();
}

//Authenticate the user
$oPerson = Pool_Person::cookie_auth();
if(!$oPerson){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'failed auth');
	run_smarty();
}

//Unescape the URL encoding in $_POST
foreach($_POST as &$postvar) {
	$postvar = urldecode($postvar);
	$postvar = stripslashes($postvar);
}

//Set up the data array to pass to Pool_Intent
//First match up contributors with their roles
$intent_data = array();
$intent_data['contributors'] = array();
$contributor_count = 0;
foreach($_POST as $key=>$field){
	if(strpos($key, 'contributor') !== false) $contributor_count++;
}
for($i=1; $i <= $contributor_count; $i++){
	$id_label = 'contributor'.$i;
	if($_POST[$id_label] != '177'){
	//177 is the ID of the empty user (legacy, sorry.)
		$roles_label = 'roles'.$i;
		$roles_array = explode('|', $_POST[$roles_label]);
		$intent_data['contributors'][$_POST[$id_label]] = $roles_array;
	}
}
//Split the behaviors (no behaviors for code)
//$intent_data['aspects'] = explode('|', $_POST['behaviors']);
$intent_data['aspects'] = array();
//Put the subjects into an array
$intent_data['subjects'] = array();
$subject_count = 0;
foreach($_POST as $key=>$field){
	if(strpos($key, 'subject') !== false) $subject_count++;
}
for($i=1; $i <= $subject_count; $i++){
	$id_label = 'subject'.$i;
	$intent_data['subjects'][] = $_POST[$id_label];
}
//Add the rest of the required data
$intent_data['requests'] = $_POST['requests'];
$intent_data['description'] = $_POST['description'];
$intent_data['title'] = $_POST['title'];
$intent_data['uri_view'] = $_POST['uri_view'];
$intent_data['pool_type'] = 'code';
$intent_data['stage'] = 'intent';
$intent_data['recorder_id'] = $oPerson['id'];
$intent_data['intent_id'] = $_POST['intentId'];

//Add the review
$oIntent = new Pool_Intent($intent_data);
$oProject = new Code_Project(Pool_Project::resolve_artifact_id('intent', $oIntent->id));

if(!$oProject || !$oIntent){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'failed intent or project');
	run_smarty();
} else {
	$smarty->assign('panelId', $_POST['panelId']);
	$smarty->assign('project_panelId', $_POST['projectPanelId']);
	$project_js = Pool_Project::get_cached_js_short($oProject->id);
	$smarty->assign('project_js', $project_js);
	if($intent_data['intent_id'] == -1) $smarty->assign('edit', false);
	else $smarty->assign('edit', true);
	$smarty->assign('success', true);
	run_smarty();
}

function run_smarty(){
	$smarty = &$GLOBALS['smarty'];

	$smarty->left_delimiter = '<{';
	$smarty->right_delimiter = '}>';		
	$smarty->display('js_code_intent_handler.tpl');
	$smarty->left_delimiter = '{';
	$smarty->right_delimiter = '}';	 
	die();
}
?>