<?PHP
//inserts a new approach into the database
//Include init files
require_once('../../pool_init.php');
require_once('smarty_init.php');
require_once('db_init.php');
require_once('person.class.php');
require_once('pool_intent.class.php');
require_once('pool_approach.class.php');
require_once('pool_release.class.php');
require_once('code_project.class.php');
require_once('review.class.php');
require_once('subject.class.php');

//Make sure all the required fields are filled
if(!isset($_POST['intentId']) || !isset($_POST['artifactType']) || !isset($_POST['approachId'])){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'missing postvars');
	run_smarty();
}

if(!isset($_POST['contributor1']) || $_POST['contributor1'] == ''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must have at least one contributor to your release.');
	run_smarty();
}

if(!isset($_POST['description']) || $_POST['description'] == ''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must describe your release.');
	run_smarty();
}

if(!isset($_POST['uri_view']) || $_POST['uri_view'] == ''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must supply a URI where your release can be viewed.');
	run_smarty();
}
if(!isset($_POST['uri_view']) || ($_POST['uri_view'] != '' && substr($_POST['uri_view'], 0, 4) != 'http')){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'The URI for your release must begin with "http://".');
	run_smarty();
}
if(!isset($_POST['uri_source']) || ($_POST['uri_source'] != '' && substr($_POST['uri_source'], 0, 4) != 'http')){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'The URI for your release source must begin with "http://".');
	run_smarty();
}

//Authenticate the user
$oPerson = Pool_Person::cookie_auth();
if(!$oPerson){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'failed auth');
	run_smarty();
}

//Unescape the URL encoding in $_POST
foreach($_POST as &$postvar) {
	$postvar = urldecode($postvar);
	$postvar = stripslashes($postvar);
}

//Set up the data array to pass to Pool_Relase
//First match up contributors with their roles
$release_data = array();
$release_data['contributors'] = array();
$contributor_count = 0;
foreach($_POST as $key=>$field){
	if(strpos($key, 'contributor') !== false) $contributor_count++;
}
for($i=1; $i <= $contributor_count; $i++){
	$id_label = 'contributor'.$i;
	if($_POST[$id_label] != '177'){
		//177 is the ID of the empty user (legacy, sorry.)		
		$roles_label = 'roles'.$i;
		if($_POST[$roles_label] == ''){
			$smarty->assign('success', false);
			$smarty->assign('reason', 'Please make sure all contributors have been assigned roles.');
			run_smarty();			
		}
		$roles_array = explode('|', $_POST[$roles_label]);
		$release_data['contributors'][$_POST[$id_label]] = $roles_array;
	}
}
//Split the rights and types
$release_data['aspects'] = explode('|', $_POST['rights']);
array_push($release_data['aspects'], $_POST['combinations']);
array_push($release_data['aspects'], $_POST['transformations']);
$release_data['custom_rights'] = $_POST['customRights'];

//Add the rest of the required data
$release_data['requests'] = $_POST['requests'];
$release_data['description'] = $_POST['description'];
$release_data['uri_view'] = $_POST['uri_view'];
$release_data['uri_source'] = $_POST['uri_source'];
$release_data['pool_type'] = 'code';
$release_data['stage'] = 'approach';
$release_data['recorder_id'] = $oPerson['id'];
$release_data['intent_id'] = $_POST['intentId'];
$release_data['approach_id'] = $_POST['approachId'];
$release_data['release_id'] = $_POST['releaseId'];

//Add the review
$oRelease = new Pool_Release($release_data);
$oProject = new Code_Project($oRelease->project_id);

if(!$oProject || !$oRelease){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'failed release or project');
	run_smarty();
} else {
	$smarty->assign('panelId', $_POST['panelId']);
	$smarty->assign('project_panelId', $_POST['projectPanelId']);
	$project_js = Pool_Project::get_cached_js_short($oProject->id);
	$smarty->assign('project_js', $project_js);
	if($release_data['release_id'] == -1) $smarty->assign('edit', false);
	else $smarty->assign('edit', true);	
	$smarty->assign('success', true);
	run_smarty();
}

function run_smarty(){
	$smarty = &$GLOBALS['smarty'];

	$smarty->left_delimiter = '<{';
	$smarty->right_delimiter = '}>';		
	$smarty->display('js_code_release_handler.tpl');
	$smarty->left_delimiter = '{';
	$smarty->right_delimiter = '}';	 
	die();
}
?>