<?PHP
//inserts a new review into the database

//Include init files
require_once('../../pool_init.php');
require_once('smarty_init.php');
require_once('db_init.php');
require_once('person.class.php');
require_once('pool_intent.class.php');
require_once('pool_approach.class.php');
require_once('pool_release.class.php');
require_once('code_project.class.php');
require_once('review.class.php');

//Make sure all the required fields are filled
if(!isset($_POST['artifactId']) || !isset($_POST['artifactType'])){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'missing postvars');
	run_smarty();
}

$rated = false;
if(isset($_POST['conceptualRating']) && $_POST['conceptualRating'] > 0) $rated = true;
if(isset($_POST['technicalRating']) && $_POST['technicalRating'] > 0) $rated = true;
if(isset($_POST['utilityRating']) && $_POST['utilityRating'] > 0) $rated = true;
if(!$rated){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must choose a rating for at least one aspect of this artifact.');
	run_smarty();	
}

//Authenticate the user
$oPerson = Pool_Person::cookie_auth();
if(!$oPerson){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'failed auth');
	run_smarty();
}

//Unescape the URL encoding in $_POST
//print_r($_POST);
foreach($_POST as &$postvar) {
	$postvar = urldecode($postvar);
	$postvar = stripslashes($postvar);
}
//print_r($_POST);

//Add the review
$review = new Code_Review($_POST);
if(!$review){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'failed review');
	run_smarty();
} else {
	$smarty->assign('panelId', $_POST['panelId']);
	$smarty->assign('reviewPanelId', $_POST['reviewPanelId']);
	$project_id = Pool_Project::resolve_artifact_id($_POST['artifactType'], $_POST['artifactId']);
	$project_js = Pool_Project::get_cached_js_short($project_id);
	$smarty->assign('project_js', $project_js);
	$smarty->assign('success', true);
	run_smarty();
}

function run_smarty(){
	$smarty = &$GLOBALS['smarty'];

	$smarty->left_delimiter = '<{';
	$smarty->right_delimiter = '}>';		
	$smarty->display('js_review_handler.tpl');
	$smarty->left_delimiter = '{';
	$smarty->right_delimiter = '}';	 
	die();
}
?>