<?PHP
//updates a person's account settings
//Include init files
require_once('../../pool_init.php');
require_once('smarty_init.php');
require_once('db_init.php');
require_once('person.class.php');
require_once('pool_intent.class.php');
require_once('pool_approach.class.php');
require_once('pool_release.class.php');
require_once('art_project.class.php');
require_once('review.class.php');
require_once('subject.class.php');

$feedback = '';
$oPerson = new Pool_Person($_POST['userID']);
$oPerson->load_ratings();

//Unescape the URL encoding in $_POST
foreach($_POST as &$postvar) {
	$postvar = urldecode($postvar);
	$postvar = stripslashes($postvar);
}

//Validate uri
if(!isset($_POST['uri']) || ($_POST['uri'] != '' && substr($_POST['uri'], 0, 4) != 'http')){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'The URI for your home page must begin with "http://".');
	run_smarty();
}

//Make sure the person being modified is the same as the one logged in (or that the logged in person is an admin)
$is_admin = Pool_Person::cookie_admin_check();
if(!isset($_POST['userID']) || $_POST['userID'] != $_COOKIE['poolid']){
	if(!$is_admin){
		$smarty->assign('success', false);
		$smarty->assign('reason', 'You do not have permissions to change this account.');
		run_smarty();		
	}
}

//Password Change
if(($_POST['oldPass'] == '') && ($_POST['newPass1'] != '' || $_POST['newPass2'] != '')){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must supply your old password and type your new password twice to enter a new password.');
	run_smarty();
} else if($_POST['newPass1'] != '' && $_POST['newPass2'] == $_POST['newPass1']){
	if(!Pool_Person::password_change($_POST['userID'], $_POST['oldPass'], $_POST['newPass1'], $is_admin)){
		$smarty->assign('success', false);
		$smarty->assign('reason', 'Password change failed: Old password is incorrect.');
		run_smarty();
	} else {
		$feedback .= 'Password changed.\n';
	}
} else if($_POST['newPass1'] != '' && $_POST['newPass2'] != ''){
		$smarty->assign('success', false);
		$smarty->assign('reason', 'New passwords do not match.');
		run_smarty();	
}

//Self Ratings
if($_POST['conceptualSelf'] != '') {
	if(!isset($oPerson->ratings['conceptual']) || $oPerson->ratings['conceptual']['self_rating'] != $_POST['conceptualSelf']) {
		Pool_Person::set_self_rating($_POST['userID'], 'conceptual', $_POST['conceptualSelf']);
		$feedback .= 'Conceptual self-rating changed.\n';
	}
}
if($_POST['perceptualSelf'] != '') {
	if(!isset($oPerson->ratings['perceptual']) || $oPerson->ratings['perceptual']['self_rating'] != $_POST['perceptualSelf']) {
		Pool_Person::set_self_rating($_POST['userID'], 'perceptual', $_POST['perceptualSelf']);
		$feedback .= 'Perceptual self-rating changed.\n';
	}
}
if($_POST['technicalSelf'] != '') {
	if(!isset($oPerson->ratings['technical']) || $oPerson->ratings['technical']['self_rating'] != $_POST['technicalSelf']) {
		Pool_Person::set_self_rating($_POST['userID'], 'technical', $_POST['technicalSelf']);
		$feedback .= 'Technical self-rating changed.\n';
	}
}
if($_POST['utilitySelf'] != '') {
	if(!isset($oPerson->ratings['utility']) || $oPerson->ratings['utility']['self_rating'] != $_POST['utilitySelf']) {
		Pool_Person::set_self_rating($_POST['userID'], 'utility', $_POST['utilitySelf']);
		$feedback .= 'Utility self-rating changed.\n';
	}
}

//Profile
Pool_Person::set_field($_POST['userID'], 'email', $_POST['email']);
Pool_Person::set_field($_POST['userID'], 'uri', $_POST['uri']);
Pool_Person::set_field($_POST['userID'], 'themes', $_POST['themes']);
Pool_Person::set_field($_POST['userID'], 'description', $_POST['description']);
$feedback .= 'Profile updated.\n';

$smarty->assign('panelId', $_POST['panelId']);
$smarty->assign('success', true);
$smarty->assign('reason', $feedback);
$oPerson->save_js();
run_smarty();

function run_smarty(){
	$smarty = &$GLOBALS['smarty'];

	$smarty->left_delimiter = '<{';
	$smarty->right_delimiter = '}>';		
	$smarty->display('js_person_handler.tpl');
	$smarty->left_delimiter = '{';
	$smarty->right_delimiter = '}';	 
	die();
}
?>