<?PHP
//inserts a new reference object into the database

//Include init files
require_once('../../pool_init.php');
require_once('smarty_init.php');
require_once('db_init.php');
require_once('subject.class.php');
require_once('person.class.php');
require_once('pool_project.class.php');
require_once('pool_reference.class.php');
require_once('attribution.class.php');

//Make sure all the required fields are filled
if($_POST['titleInput']==''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must supply a title for the artifact');
	run_smarty();	
}

if($_POST['authorInput']==''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must supply an author for the artifact');
	run_smarty();	
}

if($_POST['citation']==''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must supply a citation for the artifact');
	run_smarty();		
}

if($_POST['date_published']==''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must supply a date for the artifact');
	run_smarty();		
}
if($_POST['description']==''){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'You must supply a description for the artifact');
	run_smarty();		
}

//Authenticate the user
$oPerson = Pool_Person::cookie_auth();
if(!$oPerson){
	$smarty->assign('success', false);
	$smarty->assign('reason', 'failed auth');
	run_smarty();
}

$form_data = $_POST;

//Unescape the URL encoding in $_POST
foreach($form_data as &$postvar) {
	$postvar = urldecode($postvar);
	$postvar = stripslashes($postvar);
}


$edit = false;
$form_data['reference_id'] = -1;
//titleWritten and authorWritten are set by the typeahead
if($_POST['titleInput']==$_POST['titleWritten'] && $_POST['authorInput'] == $_POST['authorWritten']){
	//Both title and author were set by typeahead, so check to see if this is a dupe	
	$q = 'SELECT COUNT(*) FROM `reference_attribution` WHERE `attribution_id` = ? AND `reference_id` = ?';
	$result = $data->getOne($q, array($_POST['authorId'], $_POST['projectId']));
	if($result > 0){
		//dupe, so we're editing
		$edit = true;
		$form_data['reference_id'] = $_POST['projectId'];
	}
} 
//die($form_data['reference_id']);
$form_data['title'] = $_POST['titleInput'];

//Insert the author if it is a new one
if($_POST['authorInput'] != $_POST['authorWritten']){
	$q = 'INSERT INTO `attribution` (`name`) VALUES (?)';
	$result = $data->query($q, array($_POST['authorInput']));
	if(DB::isError($result)){
		$smarty->assign('success', false);
		$smarty->assign('reason', 'Attribution db insert failed.');
		run_smarty();
	}
}
if($_POST['authorInput'] == $_POST['authorWritten']) $form_data['attribution_id'] = $_POST['authorId'];
else $form_data['attribution_id'] = $data->getOne('SELECT MAX(`id`) FROM `attribution`', array());

//Connect subjects
//Make form_data['subjects'] before calling new Pool_Reference
$form_data['subjects'] = array();
foreach($_POST as $key=>$field){
	if(strpos($key, 'subject') !== false){
//		echo("console.log('".$field."');");
		if($field != '0') $form_data['subjects'][] = $field;
//		array_push($form_data['subjects'], $field);
	}
}

//Add rights information and other data
$form_data['aspects'] = explode('|', $_POST['rights']);
array_push($form_data['aspects'], $_POST['combinations']);
array_push($form_data['aspects'], $_POST['transformations']);
$form_data['custom_rights'] = $_POST['customRights'];
$form_data['pool_type'] = $_POST['pooltype'];
$form_data['recorder_id'] = $oPerson['id'];

//call new Pool_Reference
$oRef = new Pool_Reference($form_data);


$smarty->assign('panelId', $_POST['panelId']);
$ref_js = Pool_Reference::get_cached_js_short($oRef->id);
$smarty->assign('projectPanelId', $_POST['projectPanelId']);
$smarty->assign('project_js', $ref_js);
if($edit) $smarty->assign('edit', true);
else $smarty->assign('edit', false);
$smarty->assign('success', true);

run_smarty();

function run_smarty(){
	$smarty = &$GLOBALS['smarty'];

	$smarty->left_delimiter = '<{';
	$smarty->right_delimiter = '}>';		
	$smarty->display('js_reference_input_handler.tpl');
	$smarty->left_delimiter = '{';
	$smarty->right_delimiter = '}';	 
	die();
}
?>