/**
 * @author johnbell
 */
CodePanel = new Object();
CodePanel.loadPanel = function(panel, treePane, contentPane, dataArray){
//Load the artifact panel for a code project.
//dataArray is the json object for the artifact

	//add the panelId to the dataArray for future reference and store the dataArray in the panel
	dataArray.panelId = panel.panelHandle.panelId;
	panel.panelHandle.json = dataArray;
	panel.panelHandle.panelType = 'code';
	panel.panelHandle.className += ' codePanel';
	
	//First build the mouse handlers so they can be added as elements are created
	var stageMouseOver = function(e){
		var stage = browsers.getTargetElement(e);
		browsers.stopBubbling(e);
		treePane.className = treePane.className.replace(/ panelHighlightColor/	, '');
		stage.className = stage.className + ' panelHighlightColor';
	}
	
	var treeMouseOver = function(e){
		treePane.className = treePane.className + ' panelHighlightColor';
	}
	
	var stageMouseOut = function(e){
		var stage = browsers.getTargetElement(e);
		var classArray = stage.className.split(' ');
		classArray.pop();
		stage.className = classArray.join(' ');
	}
	
	var treeMouseOut = function(e){
		treePane.className = treePane.className.replace(/ panelHighlightColor/, '');
	}
	var stageMouseUp = function(e){
		browsers.stopBubbling(e);
		var stage = browsers.getTargetElement(e);
		for(var intentID in stage.panel.tree.intents) stage.panel.tree.intents[intentID].style.borderWidth = '1px';
		for(var approachID in stage.panel.tree.approaches) stage.panel.tree.approaches[approachID].style.borderWidth = '1px';
		for(var releaseID in stage.panel.tree.releases) stage.panel.tree.releases[releaseID].style.borderWidth = '1px';
		stage.style.borderWidth = '3px';
		for(var i=0; i<stage.panel.contentPanes.length; i++){
			stage.panel.contentPanes[i].style.display = 'none';
		}
		stage.contentDiv.style.display = 'block';
	}
	
	var treeMouseUp = function(e){
		var projectPane = browsers.getTargetElement(e);
		for(var intentID in projectPane.panel.tree.intents) projectPane.panel.tree.intents[intentID].style.borderWidth = '1px';
		for(var approachID in projectPane.panel.tree.approaches) projectPane.panel.tree.approaches[approachID].style.borderWidth = '1px';
		for(var releaseID in projectPane.panel.tree.releases) projectPane.panel.tree.releases[releaseID].style.borderWidth = '1px';	
		for(var i=0; i<projectPane.panel.contentPanes.length; i++){
			projectPane.panel.contentPanes[i].style.display = 'none';
		}
		projectPane.contentDiv.style.display = 'block';
	}
	
	//Add event listeners for the project level
	browsers.addEventListener('mouseover', treePane, treeMouseOver, false);
	browsers.addEventListener('mouseout', treePane, treeMouseOut, false);
	browsers.addEventListener('mouseup', treePane, treeMouseUp, false);
	
	//Build the project tabBox
	panel.tree = {intents: {}, approaches: {}, releases: {}};
	panel.contentPanes = new Array();		
	
	var contentDiv = new tabSet(['general', 'reviews', 'relationships']);
	contentDiv.tabBox.style.display = 'block';
	treePane.contentDiv = contentDiv.tabBox;
	treePane.panel = panel;
	panel.contentPanes.push(contentDiv.tabBox);
	contentPane.appendChild(contentDiv.tabBox);
		
	//add content to the tab content areas
	//general tab

	//set the thumbnail image to the default if it does not exist
	if(!dataArray.project.thumbnail || dataArray.project.thumbnail == '') dataArray.project.thumbnail = 'default-pool-icon.gif';
	else dataArray.project.thumbnail = 'image.php?id='+dataArray.project.thumbnail;


	
	var projectData = {		title: dataArray.project.title,
							pool_type: dataArray.project.pool_type,
							contributors: dataArray.project.contributors,
							date: dataArray.project.last_modified,
							thumbnail: dataArray.project.thumbnail,
							panelId: dataArray.panelId,
							hr_id: dataArray.project.hr_id,
							projectId: dataArray.project.id,
							subjects: dataArray.project.subjects};			
	CodePanel.loadProjectGeneral(contentDiv.tabBox.content['general'], projectData);

	//review tab
	var reviewData = new Array();
	//Get all reviews
	for(artifactID in dataArray.reviews){
		reviewData.push(dataArray.reviews[artifactID]);
	}
	CodePanel.loadReview(contentDiv.tabBox.content['reviews'], reviewData, 'project'); 
	//Add number of reviews to tab title
	contentDiv.tabBox.tabs['reviews'].innerHTML = 'reviews (' + reviewData.length +')';


	//Build relationship tab
	var relationshipData = new Array();
	for(relationshipID in dataArray.project.relations){
		relationshipData.push(dataArray.project.relations[relationshipID]);
	}
	CodePanel.loadRelation(contentDiv.tabBox.content['relationships'], relationshipData);
	contentDiv.tabBox.tabs['relationships'].innerHTML = 'relationships (' + relationshipData.length + ')';
	//***//
	
	//Make the project map
	for(intentID in dataArray.intents){
		panel.tree.intents[intentID] = document.createElement('div');
		panel.tree.intents[intentID].className = 'panelOutlineFG artifactPanelTreeIntent';
		panel.tree.intents[intentID].panel = panel;
		browsers.addEventListener('mouseover', panel.tree.intents[intentID], stageMouseOver, false);
		browsers.addEventListener('mouseout', panel.tree.intents[intentID], stageMouseOut, false);
		browsers.addEventListener('mouseup', panel.tree.intents[intentID], stageMouseUp, false);
		treePane.appendChild(panel.tree.intents[intentID]);
		for(approachID in dataArray.approaches){
			if(dataArray.approaches[approachID].intent_id == intentID){
				panel.tree.approaches[approachID] = document.createElement('div');
				panel.tree.approaches[approachID].className = 'panelOutlineFG artifactPanelTreeApproach';
				panel.tree.approaches[approachID].panel = panel;
				browsers.addEventListener('mouseover', panel.tree.approaches[approachID], stageMouseOver, false);
				browsers.addEventListener('mouseout', panel.tree.approaches[approachID], stageMouseOut, false);	
				browsers.addEventListener('mouseup', panel.tree.approaches[approachID], stageMouseUp, false);				
				treePane.appendChild(panel.tree.approaches[approachID]);
				for(releaseID in dataArray.releases){
					if(dataArray.releases[releaseID].approach_id == approachID){
						panel.tree.releases[releaseID] = document.createElement('div');
						panel.tree.releases[releaseID].className = 'panelOutlineFG artifactPanelTreeRelease';
						panel.tree.releases[releaseID].panel = panel;
						browsers.addEventListener('mouseover', panel.tree.releases[releaseID], stageMouseOver, false);
						browsers.addEventListener('mouseout', panel.tree.releases[releaseID], stageMouseOut, false);
						browsers.addEventListener('mouseup', panel.tree.releases[releaseID], stageMouseUp, false);					
						treePane.appendChild(panel.tree.releases[releaseID]);		
					}
				}
			}
		}
	}
	
	
	
	//Build the intent panes
	var i=0;		//counter so that only the first intent general tab is turned on when the panel is first loaded.
	for(intentID in dataArray.intents){
		var contentDiv = new tabSet(['general', 'themes', 'requests', 'reviews']);
		contentDiv.tabBox.style.display = 'none';
		panel.tree.intents[intentID].contentDiv = contentDiv.tabBox;
		panel.contentPanes.push(contentDiv.tabBox);
		contentPane.appendChild(contentDiv.tabBox);
		
		//add content to the tab content areas
		//general tab
		
		//since intent data is split between the project and intent tables, reassemble the data into a single array that can be passed
		var intentData = {	title: dataArray.project.title,
							contributors: dataArray.intents[intentID].contributors,
							date: dataArray.intents[intentID].date,
							description: dataArray.intents[intentID].description,
							thumbnail: dataArray.project.thumbnail,
							panelId: dataArray.panelId,
							uri_view: dataArray.intents[intentID].uri_view,
							hr_id: dataArray.intents[intentID].hr_id,
							projectId: dataArray.project.id,
							intentId: intentID};			
		CodePanel.loadIntentGeneral(contentDiv.tabBox.content['general'], intentData);
		
		//themes tab
		var subjectString = '';
//		var behaviorString = '';
		for(var sub in dataArray.project.subjects) subjectString += dataArray.project.subjects[sub] + '<br />';
//		for(var behavior in dataArray.intents[intentID].aspects) behaviorString += behavior + '<br />';
		contentDiv.tabBox.content['themes'].innerHTML = panelContent.code_intent_themes;
		insertXMLTagData(contentDiv.tabBox.content['themes'], 'ppSubjects', subjectString);
//		insertXMLTagData(contentDiv.tabBox.content['themes'], 'ppBehaviors', behaviorString);
		
		//review tab
		var reviewData = new Array();
		//Isolate the reviews for this intent
		for(artifactID in dataArray.reviews){
			if(dataArray.reviews[artifactID].artifact_id == intentID && dataArray.reviews[artifactID].artifact_type == 'intent'){
				reviewData.push(dataArray.reviews[artifactID]);
			}
		}
		CodePanel.loadReview(contentDiv.tabBox.content['reviews'], reviewData, 'intent'); 
		contentDiv.tabBox.tabs['reviews'].innerHTML = 'reviews (' + reviewData.length +')';

		//write in the requests
		contentDiv.tabBox.content['requests'].innerHTML = panelContent.code_intent_requests;
		insertXMLTagData(contentDiv.tabBox.content['requests'], 'ppRequests', dataArray.intents[intentID].requests);

		if(i == 0){
			i++;
			panel.tree.intents[intentID].style.borderWidth = '3px';
		}
	}
	
	//Build the approach panes
	for(approachID in dataArray.approaches){
		var contentDiv = new tabSet(['general', 'requests', 'rights', 'reviews']);
		contentDiv.tabBox.style.display = 'none';			
		panel.tree.approaches[approachID].contentDiv = contentDiv.tabBox;
		contentDiv.tabBox.content['general'].innerHTML = approachID;
		panel.contentPanes.push(contentDiv.tabBox);
		contentPane.appendChild(contentDiv.tabBox);
		
		//add content to tabs
		//general tab
		
		var approachData = {	title: dataArray.project.title,
								type: dataArray.approaches[approachID].type,
								contributors: dataArray.approaches[approachID].contributors,
								hr_id: dataArray.approaches[approachID].hr_id,
								date: dataArray.approaches[approachID].date,
								description: dataArray.approaches[approachID].description,
								thumbnail: dataArray.project.thumbnail,
								panelId: dataArray.panelId,
								uri_view: dataArray.approaches[approachID].uri_view,
								uri_source: dataArray.approaches[approachID].uri_source,
								projectId: dataArray.project.id,
								intentId: dataArray.approaches[approachID].intent_id,
								approachId: approachID};
		CodePanel.loadApproachGeneral(contentDiv.tabBox.content['general'], approachData);
		
		//review tab
		var reviewData = new Array();
		//isolate the reviews for this approach
		for(artifactID in dataArray.reviews){
			if(dataArray.reviews[artifactID].artifact_id == approachID && dataArray.reviews[artifactID].artifact_type == 'approach'){
				reviewData.push(dataArray.reviews[artifactID]);
			}				
		}
		CodePanel.loadReview(contentDiv.tabBox.content['reviews'], reviewData, 'approach');
		contentDiv.tabBox.tabs['reviews'].innerHTML = 'reviews (' + reviewData.length +')';
		
		//write in the requests
		contentDiv.tabBox.content['requests'].innerHTML = panelContent.code_approach_requests;
		insertXMLTagData(contentDiv.tabBox.content['requests'], 'ppRequests', dataArray.approaches[approachID].requests);
		
		//write in the rights
		contentDiv.tabBox.content['rights'].innerHTML = panelContent.code_approach_rights;
		var rightsArray = [];
		for(rightName in dataArray.approaches[approachID].aspects){
			if(dataArray.approaches[approachID].aspects[rightName]==1){
				rightsArray.push(rightName);
				var glossDiv = gEBI(contentDiv.tabBox.content['rights'], 'gloss-'+rightName);
				glossDiv.style.display = 'block';
			}
		}
		var licenseName = inferLicense(dataArray.approaches[approachID].aspects);
		if(licenseName){
			gEBI(contentDiv.tabBox.content['rights'], 'gloss-'+licenseName).style.display = 'block';	
		}
		var rightsString = rightsArray.join('<br />');
		insertXMLTagData(contentDiv.tabBox.content['rights'], 'ppRights', rightsString);
		if(defined(dataArray.approaches[approachID].aspects['custom-rights']) && dataArray.approaches[approachID].aspects['custom-rights'] != ''){
			insertXMLTagData(contentDiv.tabBox.content['rights'], 'ppCustomRights', '<b>Custom Rights Notice:</b>  '+dataArray.approaches[approachID].aspects['custom-rights']);
		}
	}
	
	//Build the release panes
	for(releaseID in dataArray.releases){
		var contentDiv = new tabSet(['general', 'requests', 'rights', 'reviews']);
		contentDiv.tabBox.style.display = 'none';			
		panel.tree.releases[releaseID].contentDiv = contentDiv.tabBox;
		contentDiv.tabBox.content['general'].innerHTML = releaseID;
		panel.contentPanes.push(contentDiv.tabBox);
		contentPane.appendChild(contentDiv.tabBox);
		
		//add content to tabs
		//general tab
		
		var releaseData = {		title: dataArray.project.title,
								contributors: dataArray.releases[releaseID].contributors,
								hr_id: dataArray.releases[releaseID].hr_id,
								date: dataArray.releases[releaseID].date,
								description: dataArray.releases[releaseID].description,
								thumbnail: dataArray.project.thumbnail,
								panelId: dataArray.panelId,
								uri_view: dataArray.releases[releaseID].uri_view,
								uri_source: dataArray.releases[releaseID].uri_source,
								projectId: dataArray.project.id,
								intentId: intentID,
								approachId: approachID,
								releaseId: releaseID};
		CodePanel.loadReleaseGeneral(contentDiv.tabBox.content['general'], releaseData);
		
		//review tab
		var reviewData = new Array();
		//isolate the reviews for this approach
		for(artifactID in dataArray.reviews){
			if(dataArray.reviews[artifactID].artifact_id == releaseID && dataArray.reviews[artifactID].artifact_type == 'release'){
				reviewData.push(dataArray.reviews[artifactID]);
			}				
		}
		CodePanel.loadReview(contentDiv.tabBox.content['reviews'], reviewData, 'release');
		contentDiv.tabBox.tabs['reviews'].innerHTML = 'reviews (' + reviewData.length +')';

		//write in the requests
		contentDiv.tabBox.content['requests'].innerHTML = panelContent.code_release_requests;
		insertXMLTagData(contentDiv.tabBox.content['requests'], 'ppRequests', dataArray.releases[releaseID].requests);
		
		//write in the rights
		contentDiv.tabBox.content['rights'].innerHTML = panelContent.code_release_rights;
		var rightsArray = [];
		for(rightName in dataArray.releases[releaseID].aspects){
			if(dataArray.releases[releaseID].aspects[rightName]==1){
				rightsArray.push(rightName);
				var glossDiv = gEBI(contentDiv.tabBox.content['rights'], 'gloss-'+rightName);
				glossDiv.style.display = 'block';
			}
		}
		var licenseName = inferLicense(dataArray.releases[releaseID].aspects);
		if(licenseName){
			gEBI(contentDiv.tabBox.content['rights'], 'gloss-'+licenseName).style.display = 'block';	
		}		
		var rightsString = rightsArray.join('<br />');
		insertXMLTagData(contentDiv.tabBox.content['rights'], 'ppRights', rightsString);
		if(defined(dataArray.releases[releaseID].aspects['custom-rights']) && dataArray.releases[releaseID].aspects['custom-rights'] != ''){
			insertXMLTagData(contentDiv.tabBox.content['rights'], 'ppCustomRights', '<b>Custom Rights Notice:</b> '+dataArray.releases[releaseID].aspects['custom-rights']);
		}
		
	}
	//Add this panel to the UI's state

	workingBasin.state.panels.push(['code', dataArray.project.id]);
	if(init == false) ProtoHistoryObj.savePool(workingBasin.state);
}
CodePanel.openReviewInput = function(panelId, artifactType, artifactId, reviewId){
//panelId is the panel that launched this review panel.  artifactLevel and artifactId describe the artifact being reviewed
//reviewId is optional: if it exists, we are editing an existing review
	
	if(!browsers.readCookie('poolauth')){
		alert('You must be logged in to review an artifact.');
		return false;
	}
	
	var dataArray = panelManager[panelId].json;
	
	switch(artifactType){
		case 'intent':		var tabs = ['description', 'conceptual', 'submit'];								
							var artifactData = dataArray.intents[artifactId];								break;
		case 'approach':	var tabs = ['description', 'conceptual', 'utility', 'technical', 'submit'];	
							var artifactData = dataArray.approaches[artifactId];							break;
		case 'release': 	var tabs = ['description', 'conceptual', 'utility', 'technical', 'submit'];				
							var artifactData = dataArray.releases[artifactId];								break;
		default:	alert('no artifact type set when calling CodePanel.openReviewInput');
					return false;
	}

	titleText = arguments.length == 4 ? 'Edit Review '+dataArray.reviews[reviewId].hr_id : 'Add Review For ' + artifactData.hr_id;
	var panel = new PoolPanel(titleText, 250, 300);
	panel.panelHandle.className += ' codePanel';
	panel.panelHandle.titleControls.innerHTML = '<a href="walkthrough/#rev-describing" target="_blank">?</a> '+panel.panelHandle.titleControls.innerHTML;
	//build the tabset
	var contentDiv = new tabSet(tabs, 'review'+artifactType+artifactId);
	panel.panelContent.appendChild(contentDiv.tabBox);
	
	//Insert the form templates
	contentDiv.tabBox.content['description'].innerHTML = panelContent.code_input_review_description;
	contentDiv.tabBox.content['conceptual'].innerHTML = panelContent.code_input_review_conceptual;
	if(artifactType == 'approach' || artifactType == 'release') {
		contentDiv.tabBox.content['utility'].innerHTML = panelContent.code_input_review_utility;
		contentDiv.tabBox.content['technical'].innerHTML = panelContent.code_input_review_technical;
	}
	contentDiv.tabBox.content['submit'].innerHTML = panelContent.code_input_review_submit;
	
	//Add the hidden fields to the submit tab
	var hiddenFields = '<input type="hidden" name="artifactId" value="'+artifactId+'" />';
	hiddenFields += '<input type="hidden" name="artifactType" value="'+artifactType+'" />';
	hiddenFields += '<input type="hidden" name="poolauth" value="'+browsers.readCookie('poolauth')+'" />';
	hiddenFields += '<input type="hidden" name="panelId" value="'+panelId+'" />';
	hiddenFields += '<input type="hidden" name="reviewPanelId" value="'+panel.panelHandle.panelId+'" />';
	hiddenFields += '<input type="hidden" name="target" value="'+siteBaseDir+'ajaxHandlers/code_review_handler.js.php" />';
	insertXMLTagData(contentDiv.tabBox.content['submit'], 'ppHidden', hiddenFields);
	
	//If editing an existing review, enter the old data into the form
	var reviewArray = false;
	for(var reviewId in dataArray.reviews){
		if(dataArray.reviews[reviewId].recorder_id == browsers.readCookie('poolid') 
			&& dataArray.reviews[reviewId].artifact_type == artifactType && dataArray.reviews[reviewId].artifact_id == artifactId){
			reviewArray = dataArray.reviews[reviewId];
			break;
		}
	}
	
	if(reviewArray){
		contentDiv.tabBox.description.value = reviewArray.description;
		if(defined(reviewArray.subratings.conceptual)){
			var ratingRadio = contentDiv.tabBox.conceptualRating;
			for(var i=0; i<ratingRadio.length; i++){
				if(ratingRadio[i].value == reviewArray.subratings.conceptual.rating) ratingRadio[i].checked = true;
				else ratingRadio[i].checked = false;
			}
			contentDiv.tabBox.conceptualDescription.value = reviewArray.subratings.conceptual.description;
		}
		if(defined(reviewArray.subratings.technical)){
			var ratingRadio = contentDiv.tabBox.technicalRating;
			for(var i=0; i<ratingRadio.length; i++){
				if(ratingRadio[i].value == reviewArray.subratings.technical.rating) ratingRadio[i].checked = true;
				else ratingRadio[i].checked = false;
			}
			contentDiv.tabBox.technicalDescription.value = reviewArray.subratings.technical.description;
		}
		if(defined(reviewArray.subratings.utility)){
			var ratingRadio = contentDiv.tabBox.utilityRating;
			for(var i=0; i<ratingRadio.length; i++){
				if(ratingRadio[i].value == reviewArray.subratings.utility.rating) ratingRadio[i].checked = true;
				else ratingRadio[i].checked = false;
			}
			contentDiv.tabBox.utilityDescription.value = reviewArray.subratings.utility.description;
		}		
	}
}

CodePanel.openIntentInput = function(panelId, intentId){
//Note that panelId is optional:  if it is blank, a new intent is assumed.  If not, it is assumed that you are editing an old intent
	//get the dataArray from the calling panel if we are editing an old intent
	
	if(!browsers.readCookie('poolauth')){
		alert('You must be logged in to add an artifact.');
		return false;
	}
	
	if(arguments.length == 2){
		var projectData = panelManager[panelId].json;
	}

	var titleText = arguments.length == 0 ? 'Add Intent' : 'Edit Intent '+projectData.intents[intentId].hr_id;
	var panel = new PoolPanel(titleText, 250, 250);
	panel.panelHandle.className += ' codePanel';
	panel.panelHandle.titleControls.innerHTML = '<a href="walkthrough/#intent-basics" target="_blank">?</a> '+panel.panelHandle.titleControls.innerHTML;
	
	//Build the  tabset
//	var contentDiv = new tabSet(['basics', 'description', 'behaviors', 'requests', 'submit'], true);
	var contentDiv = new tabSet(['basics', 'description', 'requests', 'submit'], true);
	panel.panelContent.appendChild(contentDiv.tabBox);
	panel.panelContent.tabBox = contentDiv.tabBox;
	panel.panelContent.stage = 'intent';
	
	//Add tracking vars for open ended fields
	panel.panelContent.contributorCount = 0;
	panel.panelContent.subjectCount = 0;
	
	//Insert form templates
	contentDiv.tabBox.content['basics'].innerHTML = panelContent.code_input_intent_basic;
	if(arguments.length < 2){
	//Only initialize these here if there is no data to be added; otherwise, do it below.
		CodePanel.addContributorSelect(panel.panelHandle.panelId);
		contentDiv.tabBox.contributor1.value = browsers.readCookie('poolid');
		CodePanel.addSubjectSelect(panel.panelHandle.panelId);
	}
	//insertXMLSelectWidget(contentDiv.tabBox.content['basics'], 'ppSubjectSelect', 'subject1', PoolSubject);
	contentDiv.tabBox.content['description'].innerHTML = panelContent.code_input_intent_description;
//	contentDiv.tabBox.content['behaviors'].innerHTML = panelContent.code_input_intent_behaviors;
	contentDiv.tabBox.content['requests'].innerHTML = panelContent.code_input_intent_requests;
	contentDiv.tabBox.content['submit'].innerHTML = panelContent.code_input_intent_submit;
	
	//Add behaviors
	insertXMLMouseUp(contentDiv.tabBox.content['basics'], 'ppAddAttribution', 'CodePanel.addContributorSelect("'+panel.panelHandle.panelId+'")');
	insertXMLMouseUp(contentDiv.tabBox.content['basics'], 'ppAddSubject', 'CodePanel.addSubjectSelect("'+panel.panelHandle.panelId+'")');

	//Add the hidden fields to the submit tab
	//A new intent gets an id of -1
	if(arguments.length < 2) var intentId = -1;
	var hiddenFields = '<input type="hidden" name="intentId" value="'+intentId+'" />';
	hiddenFields += '<input type="hidden" name="artifactType" value="code" />';
	hiddenFields += '<input type="hidden" name="poolauth" value="'+browsers.readCookie('poolauth')+'" />';
	hiddenFields += '<input type="hidden" name="panelId" value="'+panel.panelHandle.panelId+'" />';
	hiddenFields += '<input type="hidden" name="projectPanelId" value="'+panelId+'" />';
	hiddenFields += '<input type="hidden" name="target" value="'+siteBaseDir+'ajaxHandlers/code_intent_handler.js.php" />';
	insertXMLTagData(contentDiv.tabBox.content['submit'], 'ppHidden', hiddenFields);

	//If this is an edit, fill in the form
	if(arguments.length == 2){
		var intentData = projectData.intents[intentId];
		//general tab
		contentDiv.tabBox.title.value = projectData.project.title;
		//contentDiv.tabBox.title.disabled = true;
		contentDiv.tabBox.uri_view.value = intentData.uri_view;
		var contribCount = 0;
		for(var contrib in intentData.contributors){
			contribCount++;
			CodePanel.addContributorSelect(panel.panelHandle.panelId);
			contentDiv.tabBox['contributor'+contribCount].value = contrib;
		}
		var subjectCount = 0;
		for(var subject in projectData.project.subjects){
			subjectCount++;
			CodePanel.addSubjectSelect(panel.panelHandle.panelId);
			contentDiv.tabBox['subject'+subjectCount].value = subject;
		}
		
		//description and requests
		contentDiv.tabBox.description.value = intentData.description;
		contentDiv.tabBox.requests.value = intentData.requests;
		
		//behaviors
//		for(var aspect in intentData.aspects){
//			if(intentData.aspects[aspect] == 1){
//				for(var i=0; i<contentDiv.tabBox.behaviors.length; i++){
//					if(contentDiv.tabBox.behaviors[i].value == aspect) contentDiv.tabBox.behaviors[i].checked = true;
//				}
//			}
//		}
	}
	
	
	return panel;
}

CodePanel.addSubjectSelect = function(panelId){
	//Adds a new select widget to the passed panel (assumes 'basics' tab)
	panelManager[panelId].panelContent.subjectCount++;
	var poolSubjectArray = PoolSubject;
	poolSubjectArray[0] = '- None -';
	for(var i=0; i<HiddenSubjects.length; i++){
		poolSubjectArray[HiddenSubjects[i]] = null;
	}
	insertXMLSelectWidget(panelManager[panelId].panelContent.tabBox.content['basics'], 'ppSubjectSelect', 'subject'+panelManager[panelId].panelContent.subjectCount, poolSubjectArray);
		
}

CodePanel.addContributorSelect = function(panelId){
	//Adds a new select widget to the passed panel (assumes 'basics' tab)
	panelManager[panelId].panelContent.contributorCount++;
	insertXMLSelectWidget(panelManager[panelId].panelContent.tabBox.content['basics'], 'ppContribSelect', 'contributor'+panelManager[panelId].panelContent.contributorCount, PoolPerson);
	if(panelManager[panelId].panelContent.stage == 'intent')
	CodePanel.addContributorRole(panelManager[panelId].panelContent.tabBox.content['basics'], 'ppContribSelect', 'conceptual', panelManager[panelId].panelContent.contributorCount, true);
	else{
		CodePanel.addContributorRole(panelManager[panelId].panelContent.tabBox.content['basics'], 'ppContribSelect', 'conceptual', panelManager[panelId].panelContent.contributorCount, false);
		CodePanel.addContributorRole(panelManager[panelId].panelContent.tabBox.content['basics'], 'ppContribSelect', 'utility', panelManager[panelId].panelContent.contributorCount, false);
		CodePanel.addContributorRole(panelManager[panelId].panelContent.tabBox.content['basics'], 'ppContribSelect', 'technical', panelManager[panelId].panelContent.contributorCount, false);		
	}
	
}

CodePanel.addContributorRole = function(parentDiv, xmlTag, role, count, disabledOn){
	//Adds a checkbox and icon for contributor roles at the end of the contributorSelect xml area
	var spans = parentDiv.getElementsByTagName('span');
	for(var i=0; i<spans.length; i++){
		if(spans[i].className == xmlTag){
			var check = document.createElement('input');
			check.type = 'checkbox';
			check.name = 'roles'+count;
			check.value = role;
			spans[i].appendChild(check);
			var checkIcon = document.createElement('img');
			checkIcon.src = siteBaseDir + 'media/icon-' +role+'-code.png';
			checkIcon.altText = role;
			checkIcon.title = role;
			checkIcon.style.verticalAlign = 'middle';
			spans[i].appendChild(checkIcon);
			if(disabledOn==true){
				check.checked = true;
				check.disabled = true;
			}
		}
	}
}

CodePanel.openApproachInput = function(panelId, intentId, approachId){
//panelId is the id of the panel containing the project being modified.  intentId is the Id of the intent this approach is under
//approachId is optional, and if set means that we are editing an old approach.

	if(!browsers.readCookie('poolauth')){
		alert('You must be logged in to add an artifact.');
		return false;
	}

	//get the dataArray from the calling panel
	if(!defined(panelManager[panelId].json)){
		alert('json is not set!');
		return 1;
	}
	var projectData = panelManager[panelId].json;
	
	//Create the new panel
	titleText = arguments.length == 2 ? 'Add Approach to '+projectData.intents[intentId].hr_id : 'Edit Approach '+projectData.approaches[approachId].hr_id;
	var panel = new PoolPanel(titleText, 200, 250);
	panel.panelHandle.titleControls.innerHTML = '<a href="walkthrough/#approach-basics" target="_blank">?</a> '+panel.panelHandle.titleControls.innerHTML;	
	panel.panelHandle.className += ' codePanel';
	panel.panelHandle.json = {intent: projectData.intents[intentId], project: projectData.project};
	panel.panelHandle.json.approach = arguments.length == 2 ? '' : projectData.approaches[approachId];

	//Build the tabset
	var contentDiv = new tabSet(['basics', 'description', 'type', 'rights', 'requests', 'submit'], true);
	panel.panelContent.appendChild(contentDiv.tabBox);
	panel.panelContent.tabBox = contentDiv.tabBox;
	panel.panelContent.stage = 'approach';

	//Add tracking vars for open ended fields
	panel.panelContent.contributorCount = 0;	
	
	//Insert form templates
	contentDiv.tabBox.content['basics'].innerHTML = panelContent.code_input_approach_basic;
	if(arguments.length < 3){
		CodePanel.addContributorSelect(panel.panelHandle.panelId);	
		contentDiv.tabBox.contributor1.value = browsers.readCookie('poolid');
	}
	contentDiv.tabBox.content['description'].innerHTML = panelContent.code_input_approach_description;
	contentDiv.tabBox.content['type'].innerHTML = panelContent.code_input_approach_type;
	contentDiv.tabBox.content['rights'].innerHTML = panelContent.code_input_approach_rights;
	contentDiv.tabBox.content['requests'].innerHTML = panelContent.code_input_approach_requests;
	contentDiv.tabBox.content['submit'].innerHTML = panelContent.code_input_approach_submit;

	//Add behaviors
	insertXMLMouseUp(contentDiv.tabBox.content['basics'], 'ppAddAttribution', 'CodePanel.addContributorSelect("'+panel.panelHandle.panelId+'")');

	//Add the hidden fields to the submit tab
	//A new approach gets an id of -1
	if(arguments.length < 3) var approachId = -1;
	var hiddenFields = '<input type="hidden" name="intentId" value="'+intentId+'" />';
	hiddenFields += '<input type="hidden" name="approachId" value="'+approachId+'" />';
	hiddenFields += '<input type="hidden" name="artifactType" value="code" />';
	hiddenFields += '<input type="hidden" name="poolauth" value="'+browsers.readCookie('poolauth')+'" />';
	hiddenFields += '<input type="hidden" name="panelId" value="'+panel.panelHandle.panelId+'" />';
	hiddenFields += '<input type="hidden" name="projectPanelId" value="'+panelId+'" />';
	hiddenFields += '<input type="hidden" name="target" value="'+siteBaseDir+'ajaxHandlers/code_approach_handler.js.php" />';
	insertXMLTagData(contentDiv.tabBox.content['submit'], 'ppHidden', hiddenFields);
	
	//Initialize rights panel
	if(arguments.length == 3){
		var licenseInit = {termsObj: projectData.approaches[approachId].aspects, containerEle: contentDiv.tabBox.content['rights'], poolType: 'creation'};
	} else {
		var licenseInit = {containerEle: contentDiv.tabBox.content['rights'], poolType: 'creation'};	
	}
	panel.panelHandle.licenseManager = new LicenseManager(licenseInit);
	
	//If this is an edit, fill in the form
	if(arguments.length == 3){
		var approachData = projectData.approaches[approachId];
		//general tab
		contentDiv.tabBox.uri_view.value = approachData.uri_view;
		contentDiv.tabBox.uri_source.value = approachData.uri_source;
		var contribCount = 0;
		for(var contrib in approachData.contributors){
			contribCount++;
			CodePanel.addContributorSelect(panel.panelHandle.panelId);
			contentDiv.tabBox['contributor'+contribCount].value = contrib;
			var roles = approachData.contributors[contrib].roles.split(',');
			var boxList = new Array();
			//ie doesn't like: for(var i=0; i<contentDiv.tabBox['roles'+contribCount].length; i++){ so have to build the nodelist			
			for(var i=0; i<contentDiv.tabBox.elements.length; i++){
				if(contentDiv.tabBox.elements[i].name == 'roles1') boxList.push(contentDiv.tabBox.elements[i]);	
			}
			for(var i=0; i<boxList.length; i++){
				for(var j=0; j<roles.length; j++){
					if(boxList[i].value == roles[j]) boxList[i].checked = true;
				}
			}
		}
		
		//description and requests
		contentDiv.tabBox.description.value = approachData.description;
		contentDiv.tabBox.requests.value = approachData.requests;
		
		//type and rights
//		for(var aspect in approachData.aspects){
//			if(approachData.aspects[aspect] == 1){
//				for(var i=0; i<contentDiv.tabBox.rights.length; i++){
//					if(contentDiv.tabBox.rights[i].value == aspect) contentDiv.tabBox.rights[i].checked = true;
//				}
//			}
//			if(aspect == 'custom rights'){
//				contentDiv.tabBox.customRights.value = approachData.aspects[aspect];
//			}
//		}
		
		var types = approachData.type.split(',');
		for(var i=0; i<types.length; i++){
			for(var j=0; j<contentDiv.tabBox.type.length; j++){
				if(contentDiv.tabBox.type[j].value == types[i]) contentDiv.tabBox.type[j].checked = true;
			}
		}
	}
	
	return panel;
}

CodePanel.openReleaseInput = function(panelId, intentId, approachId, releaseId){
//panelId is the id of the panel containing the project being modified.  intentId is the Id of the intent this release is under, approachID is the Id of the approach this release is under
//releaseId is optional, and if set means that we are editing an old approach.

	if(!browsers.readCookie('poolauth')){
		alert('You must be logged in to add an artifact.');
		return false;
	}

	//get the dataArray from the calling panel
	if(!defined(panelManager[panelId].json)){
		alert('json is not set!');
		return 1;
	}
	var projectData = panelManager[panelId].json;
	
	//Create the new panel
	titleText = arguments.length == 3 ? 'Add Release to '+projectData.approaches[approachId].hr_id : 'Edit Release '+projectData.releases[releaseId].hr_id;
	var panel = new PoolPanel(titleText, 250, 200);
	panel.panelHandle.titleControls.innerHTML = '<a href="walkthrough/#release-basics" target="_blank">?</a> '+panel.panelHandle.titleControls.innerHTML;
	panel.panelHandle.className += ' codePanel';
	panel.panelHandle.json = {intent: projectData.intents[intentId], project: projectData.project, approach: projectData.approaches[approachId]};
	panel.panelHandle.json.release = arguments.length == 3 ? '' : projectData.releases[releaseId];

	//Build the tabset
	var contentDiv = new tabSet(['basics', 'description', 'rights', 'requests', 'submit'], true);
	panel.panelContent.appendChild(contentDiv.tabBox);
	panel.panelContent.tabBox = contentDiv.tabBox;
	panel.panelContent.stage = 'release';

	//Add tracking vars for open ended fields
	panel.panelContent.contributorCount = 0;	
	
	//Insert form templates
	contentDiv.tabBox.content['basics'].innerHTML = panelContent.code_input_release_basic;
	if(arguments.length < 4) {
		CodePanel.addContributorSelect(panel.panelHandle.panelId);	
		contentDiv.tabBox.contributor1.value = browsers.readCookie('poolid');
	}
	contentDiv.tabBox.content['description'].innerHTML = panelContent.code_input_release_description;
	contentDiv.tabBox.content['rights'].innerHTML = panelContent.code_input_release_rights;
	contentDiv.tabBox.content['requests'].innerHTML = panelContent.code_input_release_requests;
	contentDiv.tabBox.content['submit'].innerHTML = panelContent.code_input_release_submit;

	//Add behaviors
	insertXMLMouseUp(contentDiv.tabBox.content['basics'], 'ppAddAttribution', 'CodePanel.addContributorSelect("'+panel.panelHandle.panelId+'")');

	//Add the hidden fields to the submit tab
	//A new approach gets an id of -1
	if(arguments.length < 4) var releaseId = -1;
	var hiddenFields = '<input type="hidden" name="intentId" value="'+intentId+'" />';
	hiddenFields += '<input type="hidden" name="approachId" value="'+approachId+'" />';
	hiddenFields += '<input type="hidden" name="releaseId" value="'+releaseId+'" />';
	hiddenFields += '<input type="hidden" name="artifactType" value="code" />';
	hiddenFields += '<input type="hidden" name="poolauth" value="'+browsers.readCookie('poolauth')+'" />';
	hiddenFields += '<input type="hidden" name="panelId" value="'+panel.panelHandle.panelId+'" />';
	hiddenFields += '<input type="hidden" name="projectPanelId" value="'+panelId+'" />';
	hiddenFields += '<input type="hidden" name="target" value="'+siteBaseDir+'ajaxHandlers/code_release_handler.js.php" />';
	//hiddenFields += '<input type="hidden" name="target" value="'+siteBaseDir+'echo_form.php" />';
	insertXMLTagData(contentDiv.tabBox.content['submit'], 'ppHidden', hiddenFields);

	//Initialize rights panel
	if(arguments.length == 4){
		var licenseInit = {termsObj: projectData.releases[releaseId].aspects, containerEle: contentDiv.tabBox.content['rights'], poolType: 'creation'};
	} else {
		var licenseInit = {containerEle: contentDiv.tabBox.content['rights'], poolType: 'creation'};	
	}
	panel.panelHandle.licenseManager = new LicenseManager(licenseInit);

	//If this is an edit, fill in the form
	if(arguments.length == 4){
		var releaseData = projectData.releases[releaseId];
		//general tab
		contentDiv.tabBox.uri_view.value = releaseData.uri_view;
		contentDiv.tabBox.uri_source.value = releaseData.uri_source;
		var contribCount = 0;
		for(var contrib in releaseData.contributors){
			contribCount++;
			CodePanel.addContributorSelect(panel.panelHandle.panelId);
			contentDiv.tabBox['contributor'+contribCount].value = contrib;
			var roles = releaseData.contributors[contrib].roles.split(',');
			var boxList = new Array();
			//ie doesn't like: for(var i=0; i<contentDiv.tabBox['roles'+contribCount].length; i++){ so have to build the nodelist			
			for(var i=0; i<contentDiv.tabBox.elements.length; i++){
				if(contentDiv.tabBox.elements[i].name == 'roles1') boxList.push(contentDiv.tabBox.elements[i]);	
			}
			for(var i=0; i<boxList.length; i++){
				for(var j=0; j<roles.length; j++){
					if(boxList[i].value == roles[j]) boxList[i].checked = true;
				}
			}
		}
		
		//description and requests
		contentDiv.tabBox.description.value = releaseData.description;
		contentDiv.tabBox.requests.value = releaseData.requests;
		
		//type and rights
//		for(var aspect in releaseData.aspects){
//			if(releaseData.aspects[aspect] == 1){
//				for(var i=0; i<contentDiv.tabBox.rights.length; i++){
//					if(contentDiv.tabBox.rights[i].value == aspect) contentDiv.tabBox.rights[i].checked = true;
//				}
//			}
//			if(aspect == 'custom rights'){
//				contentDiv.tabBox.customRights.value = releaseData.aspects[aspect];
//			}
//		}
		
	}

	
	return panel;	
}

CodePanel.loadProjectGeneral = function(targetDiv, dataObj){
//Loads data from dataObj into targetDiv using a template defined in CodePanelPages.js.php (panelContent.code_project_general)
	//Insert the template
	targetDiv.innerHTML = panelContent.code_project_general;

	//Assemble the contributor array into a div
	var isContributor = false;
	var contributorDiv = document.createElement('div');
	for(contrib in dataObj.contributors){
		var roles = dataObj.contributors[contrib].roles.split(',');
		for(var i=0; i<roles.length; i++){
			var roleImg = contributorDiv.appendChild(document.createElement('img'));
			roleImg.src = siteBaseDir + 'media/icon-'+roles[i]+'-code.png';
			roleImg.altText = roles[i];
			roleImg.title = roles[i];
			roleImg.style.verticalAlign = 'middle';
			browsers.setFloat(roleImg, 'left');
			//roleImg.style.float = 'left';
		}
		var contribFish = new PersonFish(contrib, dataObj.contributors[contrib].written);
		contributorDiv.appendChild(contribFish.fishSpan);
		var versionSpan = document.createElement('span');
		versionSpan.innerHTML = ' (' + dataObj.contributors[contrib].versions + ' versions)';
		contributorDiv.appendChild(versionSpan);
		var brTag = document.createElement('br');
		brTag.clear = 'left';
		contributorDiv.appendChild(brTag);
		if(contrib == browsers.readCookie('poolid')) isContributor = true;
	}
	
	//insert data
	insertXMLTagData(targetDiv, 'ppTitleText', dataObj.title);
	insertXMLTagChild(targetDiv, 'ppContributors', contributorDiv);
	insertXMLTagData(targetDiv, 'ppLastUpdated', poolDateTransform(dataObj.date));

	insertXMLSrc(targetDiv, 'ppIcon', dataObj.thumbnail);
	if(isContributor || browsers.readCookie('poollevel') == 2) {
		insertXMLTagData(targetDiv, 'ppThumbUpload', '+ Add Icon');
		insertXMLMouseUp(targetDiv, 'ppThumbUpload', 'openThumbUpload("'+dataObj.projectId+'","project","'+dataObj.panelId+'")');
	}
	insertXMLTagData(targetDiv, 'ppRelationMap', '<a href="'+siteBaseDir+'relations_map.php?id='+dataObj.projectId+'&pool_type='+dataObj.pool_type+"\" target='_new'>Map Relationships</a>");
	insertXMLTagData(targetDiv, 'ppPermalink', '<a href="'+siteBaseDir+'code_pool.php?id='+dataObj.projectId+'">Permalink</a>');
	insertXMLMouseUp(targetDiv, 'ppRelationship', 'new RelationPanel("'+dataObj.panelId+'", "'+dataObj.projectId+'", "code", "'+addslashes(dataObj.title)+'");');
	
	var subjectString = '';
	for(var sub in dataObj.subjects) subjectString += dataObj.subjects[sub] + '<br />';
	insertXMLTagData(targetDiv, 'ppSubjects', subjectString);
}


CodePanel.loadIntentGeneral = function(targetDiv, dataObj){
//Loads data from dataObj into targetDiv using a template defined in CodePanelPages.js.php (panelContent.code_intent_general)
	//Insert the template
	targetDiv.innerHTML = panelContent.code_intent_general;
	
	//Assemble the contributor array into a div
	var isContributor = false;
	var contributorDiv = document.createElement('div')
	for(contrib in dataObj.contributors){
		var roles = dataObj.contributors[contrib].roles.split(',');
		for(var i=0; i<roles.length; i++){
			var roleImg = contributorDiv.appendChild(document.createElement('img'));
			roleImg.src = siteBaseDir + 'media/icon-'+roles[i]+'-code.png';
			roleImg.altText = roles[i];
			roleImg.title = roles[i];
			roleImg.style.verticalAlign = 'middle';
			browsers.setFloat(roleImg, 'left');
			//roleImg.style.float = 'left';
		}
		var contribFish = new PersonFish(contrib, dataObj.contributors[contrib].written);
		contributorDiv.appendChild(contribFish.fishSpan);
		var breakEle = document.createElement('br');
		breakEle.clear = 'left';
		contributorDiv.appendChild(breakEle);;
		if(contrib == browsers.readCookie('poolid')) isContributor = true;
	}
	
	//insert data
	insertXMLTagData(targetDiv, 'ppTitleText', dataObj.title);
	insertXMLTagChild(targetDiv, 'ppContributors', contributorDiv);
	insertXMLTagData(targetDiv, 'ppLastUpdated', poolDateTransform(dataObj.date));
	if(dataObj.uri_view != ''){
		insertXMLTagData(targetDiv, 'ppURI', 'View Intent');
		insertXMLMouseUp(targetDiv, 'ppURI', 'window.open("'+dataObj.uri_view+'")');
	}
	
	insertXMLTagData(targetDiv, 'ppDescription', dataObj.description);
	insertXMLSrc(targetDiv, 'ppIcon', dataObj.thumbnail);
	insertXMLMouseUp(targetDiv, 'ppAddReview', 'CodePanel.openReviewInput("'+dataObj.panelId+'", "intent", "'+dataObj.intentId+'");');
	insertXMLMouseUp(targetDiv, 'ppAddApproach', 'CodePanel.openApproachInput("'+dataObj.panelId+'", "'+dataObj.intentId+'");');
	insertXMLTagData(targetDiv, 'ppPermalink', '<a href="'+siteBaseDir+'code_pool.php?id='+dataObj.projectId+'">Permalink</a>');
	if(isContributor || browsers.readCookie('poollevel') == 2) {
		insertXMLTagData(targetDiv, 'ppEditIntent', '~ Edit Intent');
		insertXMLMouseUp(targetDiv, 'ppEditIntent', 'CodePanel.openIntentInput("'+dataObj.panelId+'", "'+dataObj.intentId+'");');
	}
	if(!isContributor){
		insertXMLTagData(targetDiv, 'ppAddReview', '+ Add Review');
		insertXMLMouseUp(targetDiv, 'ppAddReview', 'CodePanel.openReviewInput("'+dataObj.panelId+'", "intent", "'+dataObj.intentId+'");');
	}
}

CodePanel.loadApproachGeneral = function(targetDiv, dataObj){
//Loads data from dataObj into targetDiv using a template defined in CodePanelPages.js.php (panelContent.code_intent_general)
	//Insert the template
	targetDiv.innerHTML = panelContent.code_approach_general;
	
	//Assemble the contributor array into a string
	var contributorDiv = document.createElement('div');
	var isContributor = false;
	for(contrib in dataObj.contributors){
		var roles = dataObj.contributors[contrib].roles.split(',');
		for(var i=0; i<roles.length; i++){
			var roleImg = contributorDiv.appendChild(document.createElement('img'));
			roleImg.src = siteBaseDir + 'media/icon-'+roles[i]+'-code.png';
			roleImg.altText = roles[i];
			roleImg.title = roles[i];
			roleImg.style.verticalAlign = 'middle';
			browsers.setFloat(roleImg, 'left');
			//roleImg.style.float = 'left';
		}
		var contribFish = new PersonFish(contrib, dataObj.contributors[contrib].written);
		contributorDiv.appendChild(contribFish.fishSpan);
		var breakEle = document.createElement('br');
		breakEle.clear = 'left';
		contributorDiv.appendChild(breakEle);
		if(contrib == browsers.readCookie('poolid')) isContributor = true;
	}
	
	//insert data
	var version = dataObj.hr_id.split('_');
	insertXMLTagData(targetDiv, 'ppTitleText', dataObj.title);
	insertXMLTagData(targetDiv, 'ppApproachType', dataObj.type);
	insertXMLMouseUp(targetDiv, 'ppAddRelease', 'CodePanel.openReleaseInput("'+dataObj.panelId+'", "'+dataObj.intentId+'", "'+dataObj.approachId+'");');
	if(isContributor || browsers.readCookie('poollevel') == 2) {
		insertXMLTagData(targetDiv, 'ppEditApproach', '~ Edit Approach');
		insertXMLMouseUp(targetDiv, 'ppEditApproach', 'CodePanel.openApproachInput("'+dataObj.panelId+'", "'+dataObj.intentId+'", "'+dataObj.approachId+'");');
	} 
	
	if(!isContributor) {
		insertXMLTagData(targetDiv, 'ppAddReview', '+ Add Review '+version[2]);
		insertXMLMouseUp(targetDiv, 'ppAddReview', 'CodePanel.openReviewInput("'+dataObj.panelId+'", "approach", "'+dataObj.approachId+'");');
	}
	
	if(dataObj.uri_view != ''){
		insertXMLTagData(targetDiv, 'ppURI', 'View Approach Demo');
		insertXMLMouseUp(targetDiv, 'ppURI', 'window.open("'+dataObj.uri_view+'")');
	}
	if(dataObj.uri_source != ''){
		//alert(dataObj);
		insertXMLTagData(targetDiv, 'ppSourceURI', 'View Approach Source');
		insertXMLMouseUp(targetDiv, 'ppSourceURI', 'window.open("'+dataObj.uri_source+'")');	
	}
	insertXMLTagChild(targetDiv, 'ppContributors', contributorDiv);
	insertXMLTagData(targetDiv, 'ppLastUpdated', poolDateTransform(dataObj.date));
	insertXMLTagData(targetDiv, 'ppDescription', dataObj.description);
	insertXMLTagData(targetDiv, 'ppPermalink', '<a href="'+siteBaseDir+'code_pool.php?id='+dataObj.projectId+'">Permalink</a>');
	insertXMLTagData(targetDiv, 'ppVersion', version[2]);
	
	insertXMLSrc(targetDiv, 'ppIcon', dataObj.thumbnail);
}

CodePanel.loadReleaseGeneral = function(targetDiv, dataObj){
//Loads data from dataObj into targetDiv using a template defined in CodePanelPages.js.php (panelContent.code_intent_general)
	//Insert the template
	targetDiv.innerHTML = panelContent.code_release_general;
	
	//Assemble the contributor array into a string
	var contributorDiv = document.createElement('div');
	var isContributor = false;
	for(contrib in dataObj.contributors){
		var roles = dataObj.contributors[contrib].roles.split(',');
		for(var i=0; i<roles.length; i++){
			var roleImg = contributorDiv.appendChild(document.createElement('img'));
			roleImg.src = siteBaseDir + 'media/icon-'+roles[i]+'-code.png';
			roleImg.altText = roles[i];
			roleImg.title = roles[i];
			roleImg.style.verticalAlign = 'middle';
			browsers.setFloat(roleImg, 'left');
			//roleImg.style.float = 'left';
		}
		var contribFish = new PersonFish(contrib, dataObj.contributors[contrib].written);
		contributorDiv.appendChild(contribFish.fishSpan);
		var breakEle = document.createElement('br');
		breakEle.clear = 'left';
		contributorDiv.appendChild(breakEle);
		if(contrib == browsers.readCookie('poolid')) isContributor = true;
	}
	//insert data
	var version = dataObj.hr_id.split('_');
	insertXMLTagData(targetDiv, 'ppTitleText', dataObj.title);
	if(isContributor || browsers.readCookie('poollevel') == 2) {
		insertXMLTagData(targetDiv, 'ppEditRelease', '~ Edit Release');
		insertXMLMouseUp(targetDiv, 'ppEditRelease', 'CodePanel.openReleaseInput("'+dataObj.panelId+'", "'+dataObj.intentId+'", "'+dataObj.approachId+'", "'+dataObj.releaseId+'");');
	}
	if(!isContributor){
		insertXMLTagData(targetDiv, 'ppAddReview', '+ Add Review '+version[2]);
		insertXMLMouseUp(targetDiv, 'ppAddReview', 'CodePanel.openReviewInput("'+dataObj.panelId+'", "release", "'+dataObj.releaseId+'");');	
	}
	
	if(dataObj.uri_view != ''){
		insertXMLTagData(targetDiv, 'ppURI', 'View Release Demo');
		insertXMLMouseUp(targetDiv, 'ppURI', 'window.open("'+dataObj.uri_view+'")');
	}
	if(dataObj.uri_source != ''){
		insertXMLTagData(targetDiv, 'ppSourceURI', 'View Release Source');
		insertXMLMouseUp(targetDiv, 'ppSourceURI', 'window.open("'+dataObj.uri_source+'")');	
	}	
	insertXMLTagChild(targetDiv, 'ppContributors', contributorDiv);
	insertXMLTagData(targetDiv, 'ppLastUpdated', poolDateTransform(dataObj.date));
	insertXMLTagData(targetDiv, 'ppDescription', dataObj.description);
	insertXMLTagData(targetDiv, 'ppPermalink', '<a href="'+siteBaseDir+'code_pool.php?id='+dataObj.projectId+'">Permalink</a>');
	insertXMLTagData(targetDiv, 'ppVersion', version[2]);	
	insertXMLSrc(targetDiv, 'ppIcon', dataObj.thumbnail);
}

CodePanel.loadRelation = function(targetDiv, dataObj){
	//Loads data from dataObj into targetDiv using a template defined in relation.fragment.tpl\

	for(var i=0; i<dataObj.length; i++){
		var workingFrag = loadFragmentToStage('relation_frag');
		//Subject
		if(dataObj[i].subject_type.indexOf('reference') != -1){
			var subjectSpan = '<span class="clickable" onmouseup="var tempFish = new ReferenceFish(\''+dataObj[i].subject+'\', \'temp\', \''+dataObj[i].subject_type+'\'); tempFish.launchPanel();">'+dataObj[i].subject_title+'</span>';	
		} else {
			var subjectFish = dataObj[i].subject_type.slice(0,1).toUpperCase() + dataObj[i].subject_type.slice(1) + 'Fish';
			var subjectSpan = '<span class="clickable" onmouseup="var tempFish = new '+subjectFish+'({id:\''+dataObj[i].subject+'\', title: \''+dataObj[i].subject_title+'\'}); tempFish.launchPanel();">'+dataObj[i].subject_title+'</span>';
		}

		//Predicate
		if(dataObj[i].predicate_type.indexOf('reference') != -1){
			var predicateSpan = '<span class="clickable" onmouseup="var tempFish = new ReferenceFish(\''+dataObj[i].predicate+'\', \'temp\', \''+dataObj[i].predicate_type+'\'); tempFish.launchPanel();">'+dataObj[i].predicate_title+'</span>';	
		} else {
			var predicateFish = dataObj[i].predicate_type.slice(0,1).toUpperCase() + dataObj[i].predicate_type.slice(1) + 'Fish';
			var predicateSpan = '<span class="clickable" onmouseup="var tempFish = new '+predicateFish+'({id:\''+dataObj[i].predicate+'\', title: \''+dataObj[i].predicate_title+'\'}); tempFish.launchPanel();">'+dataObj[i].predicate_title+'</span>';
		}
		var relationString = subjectSpan + ' ' + dataObj[i].relationship + ' ' + predicateSpan;
		insertXMLTagDataFragment('ppRelation', relationString, workingFrag);
		insertXMLTagDataFragment('ppDescription', dataObj[i].description, workingFrag);
		insertXMLTagDataFragment('ppRecorder', dataObj[i].recorder_written, workingFrag);
		
		insertXMLMouseUp(workingFrag, 'ppRecorder', 'var tempFish = new PersonFish("'+dataObj[i].recorder_id+'","'+dataObj[i].recorder_written+'");tempFish.launchPanel();');
		
		targetDiv.appendChild(workingFrag);
	}
}

CodePanel.loadReview = function(targetDiv, dataObj, reviewStage){
//Loads data from dataObj into targetDiv using a template defined in review.fragment.tpl (looping)
	var assembled = "";
	for(var i=0; i<dataObj.length; i++){
		//load the fragment to the stage so we can work with it
		var stageName = 'code_'+dataObj[i].artifact_type+'_review_frag';
		var workingFrag = loadFragmentToStage(stageName);
		//send data to the stage
		insertXMLTagDataFragment('ppReviewRating', dataObj[i].rating, workingFrag);
		insertXMLTagDataFragment('ppReviewAuthor', dataObj[i].recorder_written, workingFrag);
		insertXMLTagDataFragment('ppReview', dataObj[i].description, workingFrag);

		insertXMLMouseUp(workingFrag, 'ppReviewAuthor', 'var tempFish = new PersonFish("'+dataObj[i].recorder_id+'","'+dataObj[i].recorder_written+'");tempFish.launchPanel();');


		var hrString = new String(dataObj[i].hr_link);
		var hrSplit = hrString.split('_');
		var version = hrSplit[hrSplit.length - 1];
		var artifactType = dataObj[i].artifact_type.substring(0,1).toUpperCase() + dataObj[i].artifact_type.substring(1,dataObj[i].artifact_type.length);
		if(hrSplit.length < 5) version = artifactType;
		else version = artifactType + ' ' + version;
		insertXMLTagDataFragment('ppVersion', version, workingFrag);

		if(dataObj[i].subratings.conceptual && dataObj[i].subratings.conceptual != ''){
			insertXMLTagDataFragment('ppConceptualRating', dataObj[i].subratings.conceptual.rating, workingFrag);
			insertXMLTagDataFragment('ppConceptual', dataObj[i].subratings.conceptual.description, workingFrag);
		}
		if(reviewStage == 'approach' || reviewStage == 'release' || reviewStage == 'project'){
			if(dataObj[i].subratings.utility && dataObj[i].subratings.utility != ''){
				insertXMLTagDataFragment('ppUtilityRating', dataObj[i].subratings.utility.rating, workingFrag);
				insertXMLTagDataFragment('ppUtility', dataObj[i].subratings.utility.description, workingFrag);	
			}

			if(dataObj[i].subratings.technical && dataObj[i].subratings.technical != ''){
				insertXMLTagDataFragment('ppTechnicalRating', dataObj[i].subratings.technical.rating, workingFrag);
				insertXMLTagDataFragment('ppTechnical', dataObj[i].subratings.technical.description, workingFrag);			
			}
		}
		//Append working fragment to assembled string
		targetDiv.appendChild(workingFrag);
	}
}

Loader.registerFile('CodePanel.js');
