
//Begin code refernce
CodeReferencePanel = new Object();
CodeReferencePanel.loadPanel = function(panel, contentPane, dataArray){
	//Loads data for a code reference panel

	//add the panelId to the dataArray for future reference and store the dataArray in the panel
	dataArray.panelId = panel.panelHandle.panelId;
	panel.panelHandle.className += ' codeReferencePanel'
	panel.panelHandle.json = dataArray;
	panel.panelHandle.panelType = 'codereference';
	
	//Build tabbox
	panel.contentDiv = new tabSet(['general', 'reviews', 'rights', 'relationships']);
	panel.contentDiv.tabBox.style.display = 'block';
	contentPane.appendChild(panel.contentDiv.tabBox);
	panel.panelHandle.tabBox = panel.contentDiv.tabBox;

	//Assign templates
	panel.contentDiv.tabBox.content['general'].innerHTML = panelContent.code_reference_general;
	panel.contentDiv.tabBox.content['rights'].innerHTML = panelContent.code_reference_rights;

	//Insert data
	//General
	var targetDiv = panel.contentDiv.tabBox.content['general'];
	insertXMLTagData(targetDiv, 'ppTitleText', dataArray.reference.title);
	insertXMLTagData(targetDiv, 'ppDescription', dataArray.reference.description);
	insertXMLMouseUp(targetDiv, 'ppEdit', 'CodeReferencePanel.loadInput("'+dataArray.panelId+'");');
	insertXMLMouseUp(targetDiv, 'ppThumbUpload', 'openThumbUpload("'+dataArray.reference.id+'","reference","'+dataArray.panelId+'")');
	insertXMLMouseUp(targetDiv, 'ppRelationship', 'new RelationPanel("'+dataArray.panelId+'", "'+dataArray.reference.id+'", "codereference", "'+addslashes(dataArray.reference.title)+'");');
	insertXMLMouseUp(targetDiv, 'ppAddReview', 'CodeReferencePanel.openReviewInput("'+dataArray.panelId+'", "'+dataArray.reference.id+'");');
	insertXMLTagData(targetDiv, 'ppRelationMap', '<a href="'+siteBaseDir+'relations_map.php?id='+dataArray.reference.id+'&pool_type='+dataArray.reference.pool_type+"\" target='_new'>Map Relationships</a>");
	if(dataArray.reference.source_url != ''){
		insertXMLTagData(targetDiv, 'ppURI', 'View Reference');
		insertXMLMouseUp(targetDiv, 'ppURI', 'window.open("'+dataArray.reference.source_url+'")');
	}
	insertXMLTagData(targetDiv, 'ppPermalink', '<a href="'+siteBaseDir+'codereference_pool.php?id='+dataArray.reference.id+'">Permalink</a>');
	
	if(!dataArray.reference.thumbnail || dataArray.reference.thumbnail == '') dataArray.reference.thumbnail = 'default-pool-icon.gif';
	else dataArray.reference.thumbnail = 'image.php?id='+dataArray.reference.thumbnail;
	
	insertXMLSrc(targetDiv, 'ppIcon', dataArray.reference.thumbnail);

	var attribDiv = document.createElement('div');
	for(attrib in dataArray.reference.attribution){
		attribDiv.innerHTML += dataArray.reference.attribution[attrib] + '<br />';
	}
	insertXMLTagChild(targetDiv, 'ppAttribution',attribDiv);
	insertXMLTagData(targetDiv, 'ppCitation', dataArray.reference.citation);
	var recorderFish = new PersonFish(dataArray.reference.recorder_id, dataArray.reference.recorder_written);
	insertXMLTagChild(targetDiv, 'ppRecorder', recorderFish.fishSpan);
	var subjectString = '';
	for(var sub in dataArray.reference.subjects) subjectString += dataArray.reference.subjects[sub] + '<br />';
	insertXMLTagData(targetDiv, 'ppSubjects', subjectString);
	
	//Rights
	var rightsArray = [];
	var targetDiv = panel.contentDiv.tabBox.content['rights'];
	targetDiv.innerHTML = panelContent.code_reference_rights;
	for(rightName in dataArray.reference.aspects){
		if(dataArray.reference.aspects[rightName]==1) {
			rightsArray.push(rightName);
			gEBI(targetDiv, 'gloss-'+rightName).style.display = 'block';
		}
	}
	var licenseName = inferLicense(dataArray.reference.aspects);
	if(licenseName){
		gEBI(targetDiv, 'gloss-'+licenseName).style.display = 'block';	
	}
	if(rightsArray.length == 0){
		var rightsString = 'All Rights Reserved';
		gEBI(targetDiv, 'gloss-all-rights-reserved').style.display = 'block';	
	}
	else var rightsString = rightsArray.join('<br />');
	insertXMLTagData(targetDiv, 'ppRights', rightsString);
	if(defined(dataArray.reference.aspects['custom-rights']) && dataArray.reference.aspects['custom-rights'] != ''){
		insertXMLTagData(targetDiv, 'ppCustomRights', '<b>Custom Rights Notice:</b> '+dataArray.reference.aspects['custom-rights']);
	}
	
	//Reviews
	var reviewData = new Array();
	//Get all reviews
	for(referenceID in dataArray.reviews){
		reviewData.push(dataArray.reviews[referenceID]);
	}
	CodeReferencePanel.loadReview(panel.contentDiv.tabBox.content['reviews'], reviewData, 'reference'); 

	//Relationships
	var targetDiv = panel.contentDiv.tabBox.content['relationships'];
	var assembled = '';
	var relationshipData = new Array();
	for(relationshipID in dataArray.reference.relations){
		relationshipData.push(dataArray.reference.relations[relationshipID]);
	}
	CodeReferencePanel.loadRelation(panel.contentDiv.tabBox.content['relationships'], relationshipData);
	
	workingBasin.state.panels.push(['codereference', dataArray.reference.id]);
	if(init == false) ProtoHistoryObj.savePool(workingBasin.state);
}

CodeReferencePanel.loadRelation = function(targetDiv, dataObj){
	//Loads data from dataObj into targetDiv using a template defined in relation.fragment.tpl\

	for(var i=0; i<dataObj.length; i++){
		var workingFrag = loadFragmentToStage('relation_frag');
		//Subject
		if(dataObj[i].subject_type.indexOf('reference') != -1){
			var subjectSpan = '<span class="clickable" onmouseup="var tempFish = new ReferenceFish(\''+dataObj[i].subject+'\', \'temp\', \''+dataObj[i].subject_type+'\'); tempFish.launchPanel();">'+dataObj[i].subject_title+'</span>';	
		} else {
			var subjectFish = dataObj[i].subject_type.slice(0,1).toUpperCase() + dataObj[i].subject_type.slice(1) + 'Fish';
			var subjectSpan = '<span class="clickable" onmouseup="var tempFish = new '+subjectFish+'({id:\''+dataObj[i].subject+'\', title: \''+dataObj[i].subject_title+'\'}); tempFish.launchPanel();">'+dataObj[i].subject_title+'</span>';
		}

		//Predicate
		if(dataObj[i].predicate_type.indexOf('reference') != -1){
			var predicateSpan = '<span class="clickable" onmouseup="var tempFish = new ReferenceFish(\''+dataObj[i].predicate+'\', \'temp\', \''+dataObj[i].predicate_type+'\'); tempFish.launchPanel();">'+dataObj[i].predicate_title+'</span>';	
		} else {
			var predicateFish = dataObj[i].predicate_type.slice(0,1).toUpperCase() + dataObj[i].predicate_type.slice(1) + 'Fish';
			var predicateSpan = '<span class="clickable" onmouseup="var tempFish = new '+predicateFish+'({id:\''+dataObj[i].predicate+'\', title: \''+dataObj[i].predicate_title+'\'}); tempFish.launchPanel();">'+dataObj[i].predicate_title+'</span>';
		}
		var relationString = subjectSpan + ' ' + dataObj[i].relationship + ' ' + predicateSpan;
		insertXMLTagDataFragment('ppRelation', relationString, workingFrag);
		insertXMLTagDataFragment('ppDescription', dataObj[i].description, workingFrag);
		insertXMLTagDataFragment('ppRecorder', dataObj[i].recorder_written, workingFrag);
		
		insertXMLMouseUp(workingFrag, 'ppRecorder', 'var tempFish = new PersonFish("'+dataObj[i].recorder_id+'","'+dataObj[i].recorder_written+'");tempFish.launchPanel();');
		
		targetDiv.appendChild(workingFrag);
	}
}

CodeReferencePanel.loadReview = function(targetDiv, dataObj){
//Loads data from dataObj into targetDiv using a template defined in review.fragment.tpl (looping)
	var assembled = "";
	for(var i=0; i<dataObj.length; i++){
		//load the fragment to the stage so we can work with it
		var workingFrag = loadFragmentToStage('codereference_reference_review_frag');
		//send data to the stage
		insertXMLTagDataFragment('ppReviewRating', dataObj[i].rating, workingFrag);
		insertXMLTagDataFragment('ppReviewAuthor', dataObj[i].recorder_written, workingFrag);
		insertXMLTagDataFragment('ppReview', dataObj[i].description, workingFrag);

		if(dataObj[i].subratings.conceptual && dataObj[i].subratings.conceptual != ''){
			insertXMLTagDataFragment('ppConceptualRating', dataObj[i].subratings.conceptual.rating, workingFrag);
			insertXMLTagDataFragment('ppConceptual', dataObj[i].subratings.conceptual.description, workingFrag);
		}
		if(dataObj[i].subratings.utility && dataObj[i].subratings.utility != ''){
			insertXMLTagDataFragment('ppUtilityRating', dataObj[i].subratings.utility.rating, workingFrag);
			insertXMLTagDataFragment('ppUtility', dataObj[i].subratings.utility.description, workingFrag);	
		}
		if(dataObj[i].subratings.technical && dataObj[i].subratings.technical != ''){
			insertXMLTagDataFragment('ppTechnicalRating', dataObj[i].subratings.technical.rating, workingFrag);
			insertXMLTagDataFragment('ppTechnical', dataObj[i].subratings.technical.description, workingFrag);			
		}
		
		insertXMLMouseUp(workingFrag, 'ppReviewAuthor', 'var tempFish = new PersonFish("'+dataObj[i].recorder_id+'","'+dataObj[i].recorder_written+'");tempFish.launchPanel();');
		
		//Append working fragment to assembled string
		targetDiv.appendChild(workingFrag);
	}
}

CodeReferencePanel.openReviewInput = function(panelId, referenceId, reviewId){
//panelId is the panel that launched this review panel.  referenceId describes the reference being reviewed
//reviewId is optional: if it exists, we are editing an existing review
	
	if(!browsers.readCookie('poolauth')){
		alert('You must be logged in to review a reference.');
		return false;
	}
	
	var dataArray = panelManager[panelId].json;
	
	var tabs = ['description', 'conceptual', 'utility', 'technical', 'submit'];	
	var referenceData = dataArray.reference;
	
	titleText = arguments.length == 3 ? 'Edit Review '+dataArray.reviews[reviewId].hr_id : 'Add Review For ' + referenceData.hr_id;
	var panel = new PoolPanel(titleText, 250, 300);
	panel.panelHandle.className += ' codeReferencePanel';
	panel.panelHandle.titleControls.innerHTML = '<a href="walkthrough/#rev-describing" target="_blank">?</a> '+panel.panelHandle.titleControls.innerHTML;
	
	//build the tabset
	var contentDiv = new tabSet(tabs, 'reviewReference'+referenceId);
	panel.panelContent.appendChild(contentDiv.tabBox);
	
	//Insert the form templates
	contentDiv.tabBox.content['description'].innerHTML = panelContent.code_input_review_description;
	contentDiv.tabBox.content['conceptual'].innerHTML = panelContent.code_input_review_conceptual;
	contentDiv.tabBox.content['utility'].innerHTML = panelContent.code_input_review_utility;
	contentDiv.tabBox.content['technical'].innerHTML = panelContent.code_input_review_technical;
	contentDiv.tabBox.content['submit'].innerHTML = panelContent.code_input_review_submit;
	
	//Add the hidden fields to the submit tab
	var hiddenFields = '<input type="hidden" name="referenceId" value="'+referenceId+'" />';
	hiddenFields += '<input type="hidden" name="referenceType" value="reference" />';
	hiddenFields += '<input type="hidden" name="poolauth" value="'+browsers.readCookie('poolauth')+'" />';
	hiddenFields += '<input type="hidden" name="panelId" value="'+panelId+'" />';
	hiddenFields += '<input type="hidden" name="reviewPanelId" value="'+panel.panelHandle.panelId+'" />';
	hiddenFields += '<input type="hidden" name="target" value="'+siteBaseDir+'ajaxHandlers/code_reference_review_handler.js.php" />';
	insertXMLTagData(contentDiv.tabBox.content['submit'], 'ppHidden', hiddenFields);
	
	//If editing an existing review, enter the old data into the form
	var reviewArray = false;
	for(var reviewId in dataArray.reviews){
		if(dataArray.reviews[reviewId].recorder_id == browsers.readCookie('poolid') &&
			dataArray.reviews[reviewId].reference_id == referenceId){
			reviewArray = dataArray.reviews[reviewId];
			break;
		}
	}
	
	if(reviewArray){
		contentDiv.tabBox.description.value = reviewArray.description;
		if(defined(reviewArray.subratings.conceptual)){
			var ratingRadio = contentDiv.tabBox.conceptualRating;
			for(var i=0; i<ratingRadio.length; i++){
				if(ratingRadio[i].value == reviewArray.subratings.conceptual.rating) ratingRadio[i].checked = true;
				else ratingRadio[i].checked = false;
			}
			contentDiv.tabBox.conceptualDescription.value = reviewArray.subratings.conceptual.description;
		}
		if(defined(reviewArray.subratings.technical)){
			var ratingRadio = contentDiv.tabBox.technicalRating;
			for(var i=0; i<ratingRadio.length; i++){
				if(ratingRadio[i].value == reviewArray.subratings.technical.rating) ratingRadio[i].checked = true;
				else ratingRadio[i].checked = false;
			}
			contentDiv.tabBox.technicalDescription.value = reviewArray.subratings.technical.description;
		}
		if(defined(reviewArray.subratings.utility)){
			var ratingRadio = contentDiv.tabBox.utilityRating;
			for(var i=0; i<ratingRadio.length; i++){
				if(ratingRadio[i].value == reviewArray.subratings.utility.rating) ratingRadio[i].checked = true;
				else ratingRadio[i].checked = false;
			}
			contentDiv.tabBox.utilityDescription.value = reviewArray.subratings.utility.description;
		}		
	}
}
CodeReferencePanel.loadInput = function(panelId){
	//Creates a new input panel for references
	
	var panel = new PoolPanel('Add Code Reference');
	panel.panelHandle.className += ' codeReferencePanel';
	var contentDiv = new tabSet(['general', 'citation', 'rights', 'description', 'submit'], true);
	contentDiv.tabBox.style.display = 'block';
	panel.panelContent.appendChild(contentDiv.tabBox);
	panel.panelContent.subjectCount = 0;
	panel.panelHandle.tabBox = contentDiv.tabBox;
	panel.panelHandle.titleControls.innerHTML = '<a href="walkthrough/#reference-title" target="_blank">?</a> '+panel.panelHandle.titleControls.innerHTML;

	if(arguments.length == 1) var dataArray = panelManager[panelId].json;
	
	//assign templates
	contentDiv.tabBox.content['description'].innerHTML = panelContent.code_reference_input_description;
	contentDiv.tabBox.content['citation'].innerHTML = panelContent.code_reference_input_citation;
	contentDiv.tabBox.content['general'].innerHTML = panelContent.code_reference_input_general;
	contentDiv.tabBox.content['rights'].innerHTML = panelContent.code_reference_input_rights;
	contentDiv.tabBox.content['submit'].innerHTML = panelContent.code_reference_input_submit;
	
	//fill in the hidden fields  *******************************************************************FIX**************
	var hiddenFields = '<input type="hidden" name="panelId" value="'+panel.panelHandle.panelId+'">';
	hiddenFields += '<input type="hidden" name="projectPanelId" value="'+panelId+'">';
	// hiddenFields += '<input type="hidden" name="subject" value="'+subjectID+'_'+subjectType+'">';
	hiddenFields += '<input type="hidden" name="pooltype" value="codereference">';
	hiddenFields += '<input type="hidden" name="target" value="'+siteBaseDir+'ajaxHandlers/reference_input_handler.js.php">';
	insertXMLTagData(contentDiv.tabBox.content['submit'], 'ppHidden', hiddenFields);

	contentDiv.tabBox.setTitle = function(e){
		//Sets the hidden fields after a click in the typeahead and does a dupe check if necessary		
		var titleInput = browsers.getTargetElement(e);
		var inputForm = titleInput.inputForm;		
		inputForm.titleInput.value = titleInput.dataArray.title;
		inputForm.projectId.value = titleInput.projectId;
		inputForm.titleWritten.value = titleInput.dataArray.title;
		inputForm.titleTypeahead.innerHTML = '';
		panelManager[titleInput.panelId].tabBox.dupeCheck(titleInput.panelId);	
	}
	
	contentDiv.tabBox.setAuthor = function(e){
		//Sets the hidden fields after a click in the typeahead and does a dupe check if necessary
		var authorInput = browsers.getTargetElement(e);
		var inputForm = authorInput.inputForm;		
		inputForm.authorInput.value = authorInput.dataArray;
		inputForm.authorId.value = authorInput.authorId;
		inputForm.authorWritten.value = authorInput.dataArray;
		inputForm.authorTypeahead.innerHTML = '';
		panelManager[authorInput.panelId].tabBox.dupeCheck(authorInput.panelId);
	}
	
	contentDiv.tabBox.dupeCheck = function(panelId){
		var inputForm = panelManager[panelId].tabBox;
		//Check to see if the title/author have both been set via typeahead click
		if(inputForm.titleInput.value == '' || inputForm.titleInput.value != inputForm.titleWritten.value) return false;
		if(inputForm.authorInput.value == '' || inputForm.authorInput.value != inputForm.authorWritten.value) return false;
		
		//make the ajax call
		var responseHandler = function(ajaxData){
			eval(ajaxData);
		}
		if(ajax.port.readyState == 0 || ajax.port.readyState == 4){
			ajax.get(siteBaseDir+'ajaxHandlers/reference_dupe_search.js.php', {referenceId: inputForm.projectId.value, attributionId: inputForm.authorId.value, panelId: panelId}, responseHandler);
		} else setTimeout('panelManager["'+panelId+'"].tabBox.dupeCheck("'+panelId+'")', 100);					
	}
	
	panel.titleSearch = function(title, panelId){
		//Does a title search on reference objects.  This function should be called on keyup from within the title search field in a panel.  It assumes that the text field has .panelId attached to it.
		//If title and panelId exist, that means this function is being called from a timeout.  (This is necessary because the ajax port may be busy when the initial keyup fires from the form field)
		if(arguments.length < 2){
		//this means the search is being called directly from the form element.
			if(this.value.length != 3) return false;
			var title = this.value;
			var panelId = this.panelId;
		}

		var responseHandler = function(ajaxData){
			eval(ajaxData);
		}
		if(ajax.port.readyState == 0 || ajax.port.readyState == 4){
			ajax.get(siteBaseDir+'ajaxHandlers/reference_title_search.js.php', {title: title, panelId: panelId}, responseHandler);
		} else setTimeout('panelManager["'+panelId+'"].panel.titleSearch("'+title+'", "'+panelId+'")', 100);
	}
	
	panel.authorSearch = function(author, panelId){
		//Does a author search on reference objects.  This function should be called on keyup from within the author search field in a panel.  It assumes that the text field has .panelId attached to it.
		//If author and panelId exist, that means this function is being called from a timeout.  (This is necessary because the ajax port may be busy when the initial keyup fires from the form field)
		if(arguments.length < 2){
		//this means the search is being called directly from the form element.
			if(this.value.length != 3) return false;
			var author = this.value;
			var panelId = this.panelId;
		}

		var responseHandler = function(ajaxData){
			eval(ajaxData);
		}
		if(ajax.port.readyState == 0 || ajax.port.readyState == 4){
			ajax.get(siteBaseDir+'ajaxHandlers/reference_author_search.js.php', {author: author, panelId: panelId}, responseHandler);
		} else setTimeout('panelManager["'+panelId+'"].panel.authorSearch("'+author+'", "'+panelId+'")', 100);
	}

	//init license manager
	if(arguments.length == 1){
		var licenseInit = {termsObj: dataArray.reference.aspects, containerEle: contentDiv.tabBox.content['rights'], poolType: 'reference'};
	} else {
		var licenseInit = {containerEle: contentDiv.tabBox.content['rights'], poolType: 'reference'};	
	}
	panel.panelHandle.licenseManager = new LicenseManager(licenseInit);

	//auto-concat citation
	var makeCite = function(e){
		var inputForm = browsers.getTargetElement(e).inputForm;
		inputForm.citation.value = inputForm.authorInput.value + '. _'+inputForm.titleInput.value+'_. '+inputForm.date_published.value.substr(0,4);
	}
	contentDiv.tabBox.tabs['citation'].inputForm = contentDiv.tabBox;
	browsers.addEventListener('mouseup', contentDiv.tabBox.tabs['citation'], makeCite, false);

	
	//set up typeaheads
	contentDiv.tabBox.titleTypeahead = document.createElement('div');
	insertXMLTagChild(contentDiv.tabBox.content['general'], 'ppTitleTypeahead', contentDiv.tabBox.titleTypeahead);
	contentDiv.tabBox.authorTypeahead = document.createElement('div');
	insertXMLTagChild(contentDiv.tabBox.content['general'], 'ppAuthorTypeahead', contentDiv.tabBox.authorTypeahead);

	//add handlers
	contentDiv.tabBox.titleInput.onkeyup = panel.titleSearch;
	contentDiv.tabBox.titleInput.panelId = panel.panelHandle.panelId;
	contentDiv.tabBox.titleInput.typeahead = contentDiv.tabBox.titleTypeahead;
	contentDiv.tabBox.authorInput.onkeyup = panel.authorSearch;
	contentDiv.tabBox.authorInput.panelId = panel.panelHandle.panelId;
	contentDiv.tabBox.authorInput.typeahead = contentDiv.tabBox.authorTypeahead;
	insertXMLMouseUp(contentDiv.tabBox.content['citation'], 'ppAddSubject', 'CodeReferencePanel.addSubjectSelect("'+panel.panelHandle.panelId+'")');
	if(arguments.length < 1) {
		CodeReferencePanel.addSubjectSelect(panel.panelHandle.panelId);
		panel.panelHandle.subjectCount++;
	}
	
	if(arguments.length==1){
		//editing an existing reference, so load the old data
		contentDiv.tabBox.titleInput.value = contentDiv.tabBox.titleWritten.value = dataArray.reference.title;
		contentDiv.tabBox.projectId.value = dataArray.reference.id;
		
		contentDiv.tabBox.date_published.value = dataArray.reference.date_published;
		contentDiv.tabBox.source_url.value = dataArray.reference.source_url;
		contentDiv.tabBox.citation.value = dataArray.reference.citation;
		contentDiv.tabBox.description.value = dataArray.reference.description;
		
		//only one of these, but it's an array in the data object
		for(var attributionId in dataArray.reference.attribution){
			contentDiv.tabBox.authorInput.value = contentDiv.tabBox.authorWritten.value = dataArray.reference.attribution[attributionId];
			contentDiv.tabBox.authorId.value = attributionId;
		}
		for(var subject in dataArray.reference.subjects){
			CodeReferencePanel.addSubjectSelect(panel.panelHandle.panelId);
			contentDiv.tabBox['subject'+panel.panelContent.subjectCount].value = subject;
			panel.panelContent.subjectCount++;
		}
	}
	
	return panel;
}

CodeReferencePanel.addSubjectSelect = function(panelId){
	//Adds a new select widget to the passed panel (assumes 'basics' tab)
	
	panelManager[panelId].panelContent.subjectCount++;
	var poolSubjectArray = PoolSubject;
	poolSubjectArray[0] = '- None -';
	for(var i=0; i<HiddenSubjects.length; i++){
		poolSubjectArray[HiddenSubjects[i]] = null;
	}
	insertXMLSelectWidget(panelManager[panelId].tabBox.content['citation'], 'ppSubjectSelect', 'subject'+panelManager[panelId].panelContent.subjectCount, PoolSubject);
	
	
//	panelManager[panelId].panelContent.subjectCount++;
//	insertXMLSelectWidget(panelManager[panelId].tabBox.content['citation'], 'ppSubjectSelect', 'subject'+panelManager[panelId].panelContent.subjectCount, PoolSubject);
}



//end code reference

Loader.registerFile('CodeReferencePanel.js');