<?PHP
//Writes out the array for mapping relationships
//Include init files
require_once('../../pool_init.php');
require_once('smarty_init.php');
require_once('db_init.php');

if(!isset($_GET['id']) || !isset($_GET['pool_type'])){
	die('missing get vars');
}

//Load the project itself
$table = is_reference($_GET['pool_type']) ? 'reference' : 'project';
$q = "SELECT `title`, `thumb_id` FROM `$table` WHERE `id` = ? AND `pool_type` = ?";
$result = $data->getRow($q, array($_GET['id'], $_GET['pool_type']));
$self = array('id' => $_GET['pool_type'].'_'.$_GET['id'], 'type' => $_GET['pool_type'], 'title' => $result['title'], 'thumb_id' => $result['thumb_id'], 'parents' => array(), 'children' => array());

//Get the parents and children
$q = "SELECT `subject_id` AS 'id', `subject_type` AS 'type', SUM(`value`) AS 'value'
		FROM `relations` 
		WHERE `predicate_id` = ? AND `predicate_type` = ?
		GROUP BY `subject_id`, `subject_type`";
$children = $data->getAll($q, array($_GET['id'], $_GET['pool_type']));

$q = "SELECT `predicate_id` AS 'id', `predicate_type` AS 'type', SUM(`value`) AS 'value'
		FROM `relations`
		WHERE `subject_id` = ? AND `subject_type` = ?
		GROUP BY `predicate_id`, `predicate_type`";
$parents = $data->getAll($q, array($_GET['id'], $_GET['pool_type']));

$grandchildren = array();
$grandparents = array();

//get grandparents and grandchildren
for($i=0; $i < count($children); $i++){
	//add this child to the self array
	$self['children'][] = $children[$i]['type'].'_'.$children[$i]['id'];
	//fill in the child data
	$table = is_reference($children[$i]['type']) ? 'reference' : 'project';
	$q = "SELECT `title`, `thumb_id` FROM `$table` WHERE `id` = ? AND `pool_type` = ?";
	$result = $data->getRow($q, array($children[$i]['id'], $children[$i]['type']));	
	$children[$i]['title'] = $result['title'];
	$children[$i]['thumb_id'] = $result['thumb_id'];
	$children[$i]['parents'] = array($self['id']);
	$children[$i]['children'] = array();
	//Get grandchildren
	$q = "SELECT `subject_id` AS 'id', `subject_type` AS 'type', SUM(`value`) AS 'value'
			FROM `relations` 
			WHERE `predicate_id` = ? AND `predicate_type` = ?
			GROUP BY `subject_id`, `subject_type`";
	$grandkids = $data->getAll($q, array($children[$i]['id'], $children[$i]['type']));	
	for($j=0; $j<count($grandkids); $j++){
		//add this grandchild to the child's array
		$children[$i]['children'][] = $grandkids[$j]['type'].'_'.$grandkids[$j]['id'];
		//fill in the grandchild's data
		$table = is_reference($grandkids[$j]['type']) ? 'reference' : 'project';
		$q = "SELECT `title`, `thumb_id` FROM `$table` WHERE `id` = ? AND `pool_type` = ?";
		$result = $data->getRow($q, array($grandkids[$j]['id'], $grandkids[$j]['type']));			
		$grandchildren[] = array(	'title' => $result['title'], 
									'thumb_id' => $result['thumb_id'],
									'id' => $grandkids[$j]['id'], 
									'type' => $grandkids[$j]['type'],
									'parents' => array($children[$i]['type'].'_'.$children[$i]['id']),
									'children' => array());
	}
}

for($i=0; $i < count($parents); $i++){
	//add this child to the self array
	$self['parents'][] = $parents[$i]['type'].'_'.$parents[$i]['id'];
	//fill in the child data
	$table = is_reference($parents[$i]['type']) ? 'reference' : 'project';
	$q = "SELECT `title`, `thumb_id` FROM `$table` WHERE `id` = ? AND `pool_type` = ?";
	$result = $data->getRow($q, array($parents[$i]['id'], $parents[$i]['type']));	
	$parents[$i]['title'] = $result['title'];
	$parents[$i]['thumb_id'] = $result['thumb_id'];
	$parents[$i]['children'] = array($self['id']);
	$parents[$i]['parents'] = array();
	//Get grandparents
	$q = "SELECT `predicate_id` AS 'id', `predicate_type` AS 'type', SUM(`value`) AS 'value'
			FROM `relations` 
			WHERE `subject_id` = ? AND `subject_type` = ?
			GROUP BY `predicate_id`, `predicate_type`";
	$grandpars = $data->getAll($q, array($parents[$i]['id'], $parents[$i]['type']));	
	for($j=0; $j<count($grandpars); $j++){
		//add this grandchild to the child's array
		$parents[$i]['parents'][] = $grandpars[$j]['type'].'_'.$grandpars[$j]['id'];
		//fill in the grandchild's data
		$table = is_reference($grandpars[$j]['type']) ? 'reference' : 'project';
		$q = "SELECT `title`, `thumb_id` FROM `$table` WHERE `id` = ? AND `pool_type` = ?";
		$result = $data->getRow($q, array($grandpars[$j]['id'], $grandpars[$j]['type']));			
		$grandparents[] = array(	'title' => $result['title'], 
									'thumb_id' => $result['thumb_id'],
									'value' => $grandpars[$j]['value'],
									'id' => $grandpars[$j]['id'], 
									'type' => $grandpars[$j]['type'],
									'parents' => array(),
									'children' => array($parents[$i]['type'].'_'.$parents[$i]['id']));
	}
}

$smarty->assign('self', $self);
$smarty->assign('parents', $parents);
$smarty->assign('children', $children);
$smarty->assign('grandparents', $grandparents);
$smarty->assign('grandchildren', $grandchildren);

run_smarty();
function is_reference($pool_type){
	if(strpos($pool_type, 'ref') === false) return false;
	else return true;
}

function run_smarty(){
	$smarty = &$GLOBALS['smarty'];

	$smarty->left_delimiter = '<{';
	$smarty->right_delimiter = '}>';		
	$smarty->display('js_relation_map.tpl');
	$smarty->left_delimiter = '{';
	$smarty->right_delimiter = '}';	 
	die();
}
?>