<?PHP
//Form and handler for uploading images v.4
//Include init files
require_once('../pool_init.php');
require_once('smarty_init.php');
require_once('db_init.php');
require_once('person.class.php');
//require_once('review.class.php');
//require_once('art_project.class.php');
//require_once('pool_intent.class.php');
//require_once('pool_approach.class.php');
//require_once('pool_release.class.php');
//require_once('pool_project.class.php');
//require_once('art_project.class.php');
require_once('pool.class.php');
require_once('rss/rss10.inc');

header('Content-type: text/xml');

function get_image_tag($id){
	$image_name = $id > 0 ? 'image.php?id='.$id : 'default-pool-icon.png';
	return '<img align="left" style="border: 0px; padding: 3px;" src="'.POOL_HOME_URL.$image_name.'">';
}

if(isset($_GET['reviews_of'])){
	$person_id = !is_numeric($_GET['reviews_of']) ? Pool_Person::resolve_hr($_GET['reviews_of']) : $_GET['reviews_of'];
	$projects = Pool_Person::get_recent_reviews($person_id);
	$written = Pool_Person::get_written($person_id);
	$rss = new RSSWriter(POOL_HOME_URL, $written.'\'s Pool', 'Most recent reviews of '.$written.'\'s projects.');
	foreach($projects as $project){
		$image_tag = get_image_tag($project['thumb_id']);
		if(strlen($project['description']) > 200){
			$description_string = '<![CDATA['.$image_tag.'Rated '.$project['rating'].' by '.$project['written'].': '.substr(preg_replace('@<[\/\!]*?[^<>]*?>@si', '', $project['description']),0,200).'...<br clear="all" />]]>';
		} else {
			$description_string = '<![CDATA['.$image_tag.'Rated '.$project['rating'].' by '.$project['written'].': '.substr(preg_replace('@<[\/\!]*?[^<>]*?>@si', '', $project['description']),0,200).'<br clear="all" />]]>';
		}
		$title = html_entity_decode($project['title'], ENT_QUOTES);
		$pool_url = POOL_HOME_URL.$project['pool_type'].'_pool.php?id='.$project['id'];
		$rss->addItem($pool_url, $title, array('description'=>$description_string));
	}
	echo $rss->serialize();
	die();
}

if(isset($_GET['reviews_by'])){
	$person_id = !is_numeric($_GET['reviews_by']) ? Pool_Person::resolve_hr($_GET['reviews_by']) : $_GET['reviews_by'];
	$projects = Pool_Person::get_recent_reviews_by($person_id);
	$written = Pool_Person::get_written($person_id);
	$rss = new RSSWriter(POOL_HOME_URL, $written.'\'s Pool', 'Most recent reviews of '.$written.'\'s projects.');
	foreach($projects as $project){
		$image_tag = get_image_tag($project['thumb_id']);
		if(strlen($project['description']) > 200){
			$description_string = '<![CDATA['.$image_tag.'Rated '.$project['rating'].' by '.$project['written'].': '.substr(preg_replace('@<[\/\!]*?[^<>]*?>@si', '', $project['description']),0,200).'...<br clear="all" />]]>';
		} else {
			$description_string = '<![CDATA['.$image_tag.'Rated '.$project['rating'].' by '.$project['written'].': '.substr(preg_replace('@<[\/\!]*?[^<>]*?>@si', '', $project['description']),0,200).'<br clear="all" />]]>';
		}
		$title = html_entity_decode($project['title'], ENT_QUOTES);
		$pool_url = POOL_HOME_URL.$project['pool_type'].'_pool.php?id='.$project['id'];
		$rss->addItem($pool_url, $title, array('description'=>$description_string));
	}
	echo $rss->serialize();
	die();
}

if(isset($_GET['person'])){
	$person_id = !is_numeric($_GET['person']) ? Pool_Person::resolve_hr($_GET['person']) : $_GET['person'];
	$projects = Pool_Person::get_recent($person_id);
	$written = Pool_Person::get_written($person_id);
	$rss = new RSSWriter(POOL_HOME_URL, $written.'\'s Pool', 'Most recently modified projects '.$written.' has contributed to.');
	foreach($projects as $project){
		$image_tag = get_image_tag($project['thumb_id']);
		$description = array("description" => preg_replace('@<[\/\!]*?[^<>]*?>@si', '', $project['description']));
		$description_string = '<![CDATA['.$image_tag.preg_replace('@<[\/\!]*?[^<>]*?>@si', '', $project['description']).'<br clear="all" />]]>';
		$title = html_entity_decode($project['title'], ENT_QUOTES);
		$pool_url = POOL_HOME_URL.$project['pool_type'].'_pool.php?id='.$project['id'];
		$rss->addItem($pool_url, $title, array('description'=>$description_string));
	}
	echo $rss->serialize();
	die();
}

if(isset($_GET['requests'])){
	$stages = array('intent', 'approach', 'release');
	$projects = array();
	foreach($stages as $stage){
		$q = "SELECT DISTINCT `project`.`id`, `project`.`pool_type`, `project`.`thumb_id`, `$stage`.`requests`, `project`.`title`, UNIX_TIMESTAMP(`$stage`.`date`) AS time 
				FROM `$stage`, `project`, `project_artifact` 
				WHERE `$stage`.`requests` <> '' 
					AND `$stage`.`id` = `project_artifact`.`artifact_id` 
					AND `project_artifact`.`artifact_type` = ? 
					AND `project_artifact`.`project_id` = `project`.`id` ORDER BY `$stage`.`date` DESC LIMIT 0,10";

		$result = $data->getAll($q, array($stage));	
		if(DB::isError($result)){
			trigger_error("Error in rss.php.  ".$result->getMessage(), E_USER_WARNING);
			return false;	
		}
		$projects = array_merge($projects, $result);
	}
	foreach($projects as $project){
		$times[] = $project['time'];	
	}
	array_multisort($times, SORT_DESC, $projects);
	$dupes = $temp = array();
	foreach($projects as $key => $project){
		if(!in_array($project['id'], $temp)) $temp[] = $project['id'];
		else $dupes[] = $key;	
	}
	foreach($dupes as $key) unset($projects[$key]);
	$projects = array_slice(array_values($projects), 0, 10);
	
	$rss = new RSSWriter(POOL_HOME_URL, 'The Pool', 'Most recent requests made for projects in The Pool.');
	foreach($projects as $project){
		$image_name = $project['thumb_id'] > 0 ? 'image.php?id='.$project['thumb_id'] : 'default-pool-icon.png';
		$image_tag = '<img align="left" style="border: 0px; padding: 3px;" src="'.POOL_HOME_URL.$image_name.'">';
		if(strlen($project['requests']) > 400){
			$description_string = '<![CDATA['.$image_tag.substr(preg_replace('@<[\/\!]*?[^<>]*?>@si', '', $project['requests']),0,400).'...<br clear="all" />]]>';
		} else {
			$description_string = '<![CDATA['.$image_tag.substr(preg_replace('@<[\/\!]*?[^<>]*?>@si', '', $project['requests']),0,400).'<br clear="all" />]]>';
		}
		$description = array("description" => $description_string);
		$title = html_entity_decode($project['title'], ENT_QUOTES);
		$pool_url = POOL_HOME_URL.$project['pool_type'].'_pool.php?id='.$project['id'];
		$rss->addItem($pool_url, $title, $description);
	}
	echo $rss->serialize();
	die();
	
}

if(isset($_GET['pool'])){
	$pool_object = ucfirst($_GET['pool']).'_Pool';
	$oPool = new $pool_object();
	$projects = $oPool->get_recent();
	$rss = new RSSWriter(POOL_HOME_URL.$_GET['pool'].'_pool.php', ucfirst($_GET['pool']).' Pool', 'Most recently modified projects in the '.$_GET['pool'].' pool.');
	foreach($projects as $project){
		$description = array("description" => preg_replace('@<[\/\!]*?[^<>]*?>@si', '', $project['description']));
		$title = html_entity_decode($project['title'], ENT_QUOTES);
		$pool_url = POOL_HOME_URL.$project['pool_type'].'_pool.php?id='.$project['id'];
		$rss->addItem($pool_url, $title, $description);
	}
	echo $rss->serialize();
	die();
}

if(isset($_GET['themes'])){
	$q = 'SELECT `subject`.`written`, `subject`.`id` FROM `subject`, `project_subject`, `project`
			WHERE `project`.`id` = `project_subject`.`project_id`
				AND `project_subject`.`subject_id` = `subject`.`id`
			GROUP BY `subject`.`id`
			ORDER BY `project`.`last_modified` DESC LIMIT 0,15';
	$result = $data->getAll($q, array());
	$rss = new RSSWriter(POOL_HOME_URL.'theme_pool.php', 'Theme Pool', 'Most recently modified themes in the Pool.');
	foreach($result as $theme){
		$description = array("description" => preg_replace('@<[\/\!]*?[^<>]*?>@si', '', $theme['written']));
		$title = html_entity_decode($theme['written'], ENT_QUOTES);
		$pool_url = POOL_HOME_URL.'art_pool.php?theme='.$theme['written'];
		$rss->addItem($pool_url, $title, $description);
	}
	echo $rss->serialize();
	die();
}

//if no params are passed, just get the latest projects across all pools

$q = 'SELECT `project`.`description` AS description, `project`.`title` AS title, `project`.`id` AS id, `pool_type` AS pool_type,
			`project`.`thumb_id` AS thumb_id , `project`.`rating` AS rating, `project`.`last_modified` AS date
		FROM `project`
		GROUP BY `project`.`id`
		ORDER BY `project`.`last_modified` DESC LIMIT 0,5';
$result = $data->getAll($q, array());
if(DB::isError($result)){
	trigger_error("Error in rss.php.", E_USER_WARNING);
	return false;	
}

$rss = new RSSWriter(POOL_HOME_URL, 'The Pool', 'Most recently modified projects in The Pool.');
foreach($result as $project){
	$image_name = $project['thumb_id'] > 0 ? 'image.php?id='.$project['thumb_id'] : 'default-pool-icon.png';
	$image_tag = '<img align="left" style="border: 0px; padding: 3px;" src="'.POOL_HOME_URL.$image_name.'">';
	if(strlen($project['description']) > 200){
		$description_string = '<![CDATA['.$image_tag.substr(preg_replace('@<[\/\!]*?[^<>]*?>@si', '', $project['description']),0,200).'...<br clear="all" />]]>';
	} else {
		$description_string = '<![CDATA['.$image_tag.substr(preg_replace('@<[\/\!]*?[^<>]*?>@si', '', $project['description']),0,200).'<br clear="all" />]]>';
	}
	$description = array("description" => $description_string);
	$title = html_entity_decode($project['title'], ENT_QUOTES);
	$pool_url = POOL_HOME_URL.$project['pool_type'].'_pool.php?id='.$project['id'];
	$rss->addItem($pool_url, $title, $description);
}
echo $rss->serialize();
die();
?>